////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#pragma once
#include <egAPI.h>			// RT-edge system API
#include "userFunc.h"
#include "../EgCommon/edgeCommon.h"

/*****************************************************************************
*
* FILE NAME:		edgeCommon.h
*
* DESCRIPTION:		T[rXʒ`E֐@wb_t@C
*
* [TODO]:			KvɉĊe`/֐̒ǉE폜EύXsĂ   
*                   SERVICENAME ͕KύXĂ
*
\*****************************************************************************/
//////////////////////////////////////////////////////////////////////////////
/// e`ǉ
///

#define		INIT_STS_IDLE		0		// 
#define		INIT_STS_INIT		1		// 
#define		INIT_STS_INITRUN	2		// (RUNMς)
#define		INIT_STS_INITEND	3		// 

#define		WAIT_FOREVER    0xFFFFFFFF

#define		DEF_TIMEOUT			600000	//ftHg60b
#define		DEF_WAITTIMEOUT    WAIT_FOREVER	//ftHg WAIT_FOREVER
/// <summary>
/// T[rXCWP[^
/// </summary>
extern char IND_MYSERV_STATUS	[EG_MAX_TAGNAME + 1];			// T[rXN
#define		SERVICE_UP		1									// N
#define		SERVICE_DOWN	0									// ~
extern char IND_MYSERV_ERROR	[EG_MAX_TAGNAME + 1];			// T[rXG[
extern char IND_MYSERV_RUN		[EG_MAX_TAGNAME + 1];			// T[rXs
extern char IND_MYSERV_LIVE		[EG_MAX_TAGNAME + 1];			// T[rXsJE^

/// <summary>
/// T[rXvpeB^O
/// </summary>
extern char PROP_MYSERV_MODE	[EG_MAX_TAGNAME + 1];			// T[rX샂[h
#define		MODE_AUTO		1									// oTCN
#define		MODE_SEMIAUTO	2									// ̓TCN{o̓f}h
#define		MODE_MANUAL		3									// o̓f}h
#define		DEFAULT_MODE		MODE_SEMIAUTO
extern char PROP_MYSERV_CYCLE	[EG_MAX_TAGNAME + 1];			// T[rXTCN(ms)
#define		DEFAULT_CYCLE		1
extern char PROP_MYSERV_AUTORUN[EG_MAX_TAGNAME + 1];			// T[rXJn
extern char PROP_MYSERV_INPRIO	[EG_MAX_TAGNAME + 1];			// EdgeVXeւ̓̓T[rXXbhvCIeB
#define		DEFAULT_INPRIO		148
extern char PROP_MYSERV_OUTPRIO	[EG_MAX_TAGNAME + 1];			// EdgeVXȅo̓T[rXXbhvCIeB	
#define		DEFAULT_OUTPRIO		149
#define		MAX_PRIO			254
#define		MIN_PRIO			1

extern char PROP_MYSERV_IN_TRDNUM[EG_MAX_TAGNAME + 1];			// EdgeVXeւ̓̓T[rXXbh
extern char PROP_MYSERV_OUT_TRDNUM[EG_MAX_TAGNAME + 1];			// EdgeVXȅo̓T[rXXbh
#define		DEFAULT_IO_THREAD	1								// Xbhl
#define		MAX_IO_THREAD		32								// Threadől
extern char PROP_MYSERV_CONNECT[EG_MAX_TAGNAME + 1];			// ʐMڑ
extern char PROP_MYSERV_CONNECTCHK_CYCLE[EG_MAX_TAGNAME + 1];	// ʐMڑԊĎ(ms)
#define		DEFAULT_CONNECTCHK_CYCLE	1000					// ʐMڑԊĎ(ms) l
extern char PROP_MYSERV_MEASURE[EG_MAX_TAGNAME + 1];			// ԌvtO
#define		DEFAULT_EXECUTE_RECONNECT		0;					// ĐڑtO ftHgĐڑȂ

#define		DEFAULT_EXECUTE_WAITDRV			0;					// WaittO ftHg Wait삵Ȃ


extern char SERVICE_CATALOG_NAME[EG_MAX_CATALOGNAME];			// vZX̃J^O

/// <summary>
/// T[rX񋟃^O
/// </summary>
//[TODO] : Cӂ̃^Oǉ (XMLŒ`邱Ƃ𐄏)
//#define TAG_MYSERV_XXX ǉKv̏ꍇɋL
extern char TEMP_TAG_NAME[EG_MAX_TAGNAME + 1];					// ^OIpꎞϐ
extern char TAG_MYSERV_DRV_CONNECT[EG_MAX_TAGNAME + 1];			// ʐMڑ
extern char TAG_MYSERV_DRV_CONNECT_LASTERR[EG_MAX_TAGNAME + 1];	// ʐMڑԃG[ڍ

#define __FILE_NAME__		(strrchr(__FILE__, '\\') ? strrchr(__FILE__, '\\')+1 : __FILE__)
#define Log$(pServiceName, pMode, MSG, ...)	fnLog(pServiceName, pMode, MSG",%s,%05d", __VA_ARGS__, __FILE_NAME__, __LINE__)
#define WARN(reason)	WarningMsg(__LINE__,(reason))


// R[obN֐̖߂l`
#define CB_STS_OK			EDGE_SUCCESS	// 
#define CB_STS_ERROR		0x00000001			// \G[
#define CB_STS_UNRECOVERY	0x00000010			// s\G[
#define CB_STS_FATALERR		0x00000100			// vIG[

//------------------------------------------------------------------------------
// T[rX
//------------------------------------------------------------------------------
typedef struct MYSTATE
{
	uint8_t		InitStatus;		// T[rX(0:, 1:, 2:(RunMς), 3:)
	uint8_t		Status;			// CWP[^.GbWVXeڑ
	bool		Run;			// CWP[^.T[rXs
	bool		Error;			// CWP[^.T[rXُ
	uint32_t	Live;			// CWP[^.T[rXsJE^
	uint64_t	StartTime;		// CWP[^.T[rXJñ^CX^v
	uint32_t	Cycle;			// vpeB.T[rXsTCN(ms)	[TODO] : KvɉĎ
	uint8_t		Mode;			// vpeB.T[rXs[h
	uint8_t		InPriority;		// vpeB.T[rX()vCIeB	[TODO] : KvɉĎ
	uint8_t		OutPriority;	// vpeB.T[rX(o)vCIeB	[TODO] : KvɉĎ
	uint8_t		InThreadNum;	// vpeB.T[rX()Xbh	[TODO] : KvɉĎ
	uint8_t		OutThreadNum;	// vpeB.T[rX(o)Xbh	[TODO] : KvɉĎ
	bool		Connect;		// vpeB.ʐMڑς݃tO	[TODO] : KvɉĎ
	uint32_t	ConnectChkCycle;// vpeB.ʐMڑԊĎ(ms)	[TODO] : KvɉĎ
	bool		IsMeasure;		// vpeB.ԌvtO	[TODO] : KvɉĎ
	bool		EndStartFlag;	// Start Service֐xłIǂ̃tO	
	uint32_t	dwReConnectCount;	// vpeB.ĐڑsJEg
	uint8_t		OutputDifferentFlag; // lႤꍇ̂ݏo͂tO
	uint32_t	dwConnectErrorCount; // CWP[^.ڑG[JEg
	uint32_t	Timeout;              // vpeB.APIĂяõ^CAEg
	bool		ExecuteReConnect; // vpeB.sĐڑ邩ۂ̃tO
	uint32_t	WaitTimeout;      // vpeB.Wait֐Ăяõ^CAEg
	bool		ExecuteWaitDrv;	//vpeB.hCõCxg󂯎œ삷邩ۂ̃tO
	bool		UseKernelTick;	//vpeB.J[leBbNŃTCN񂷂ۂtO
//[TODO] : Cӂ̃Xe[^Xǉ
} EgState;

//------------------------------------------------------------------------------
// Xbh\
//------------------------------------------------------------------------------
typedef struct IO_TRDINFO
{
	WORD		woID;						// XbhID
	RTHANDLE	hThread;					// Xbhnh
	uint32_t	dwStackSize;				// X^bNTCY
	uint8_t		byPriority;					// XbhvCIeB
	uint8_t		reserve1[1];				// \
	RTHANDLE	hTrigSem;					// o̓gKZ}tHnh
	uint32_t	dwOpeCnt;                   // Xbh
	float		flTime;                     // Xbh
	float		flTimeMin;                  // XbhŒZ
	float		flTimeMax;                  // XbhŒ
	void*		pEntryThreadCnt;            // Xbh ̃^OEntry
	void*		pEntryThreadTime;           // Xbh ̃^OEntry
	void*		pEntryThreadTimeMin;        // XbhŒZ ̃^OEntry
	void*		pEntryThreadTimeMax;        // XbhŒ ̃^OEntry
	void*		pEntryThreadLastErr;        // XbhŐVG[l ̃^OEntry
	void*		pEntryThreadEdgeLastErr;    // XbhŐVG[l(edge APIG[) ̃^OEntry
}IO_TRDINFO;

//------------------------------------------------------------------------------
// t[[N֘A\
//------------------------------------------------------------------------------
typedef struct tEgFWdesc
{
	IO_TRDINFO			stThreadInTbl[MAX_IO_THREAD];	// ̓Xbhe[u
	IO_TRDINFO			stThreadOutTbl[MAX_IO_THREAD];	// o̓Xbhe[u
	void*				cb_ConnectChk;		// foCXڑ`FbN R[obN֐
	void*				cb_ReConnect;		// foCXĐڑ R[obN֐
	EgDevDesc*			pDevDesc;			// foCXŗL`
	char				chRSL[256];			// RSLpX
	RTHANDLE			hRslLib;			// X RSL (vgR)
	LPPROC				RSLHiInit;			// RSL HiInit֐
	LPPROC				RSLHiOpen;			// RSL HiOpen֐
	LPPROC				RSLHiClose;			// RSL HiClose֐
	LPPROC				RSLHiRead;			// RSL HiRead֐
	LPPROC				RSLHiWrite;			// RSL HiWrite֐
	LPPROC				RSLHiReConnect;		// RSL HiReConnect֐	Ă悢
	LPPROC				RSLHiConnectChk;	// RSL HiConnectChk֐ Ă悢
	LPPROC				RSLHiWait;			// RSL HiWait֐	Ă悢
	IFHANDLE			hIF;				// InitŎ擾nh
	RSIHANDLE			hRsi;				// OpenŎ擾nh
	void*				pEntryConnectLastErr; // ڑԍŐVG[l ̃^OEntry
}EgFWdesc;

// O[oϐ
EgState		MyState;		// Xe[^X֘A
EgFWdesc	MyFwDesc;		// t[[N֘A(R[obNł̃p[^nɎgp)

// R[obN֐`
typedef DWORD(*p_funcINIT)(EgFWdesc*, DWORD*);							//foCX
typedef DWORD(*p_funcOPEN)(EgFWdesc*, DWORD*);							//foCXI[v
typedef DWORD(*p_funcCLOSE)(EgFWdesc*, DWORD*);							//foCXN[Y
typedef DWORD(*p_funcREAD)(EgFWdesc*, WORD, uint64_t, void*, long size, long bufsize, EGIOPORT*);	//foCX͏
typedef DWORD(*p_funcWRITE)(EgFWdesc*, WORD, uint64_t, void*, long size, EGIOPORT*);	//foCXo͏
typedef BOOL(*p_funcConnectChk)(EgFWdesc*, DWORD*);				//foCXڑ`FbN
typedef DWORD(*p_funcReConnect)(EgFWdesc*, DWORD*);						//foCXĐڑ
typedef int32_t(*p_funcMSGHandler)(const char* sender, int32_t msgno, void *param);	//bZ[Wnh[
typedef DWORD(*p_funcWAIT)(EgFWdesc*, DWORD*);							//Jnҋ@֐

// R[obN֐|C^
p_funcINIT			cbp_Init;									//foCX
p_funcOPEN			cbp_Open;									//foCXI[v
p_funcCLOSE			cbp_Close;									//foCXN[Y
p_funcREAD			cbp_Read;									//foCX͏
p_funcWRITE			cbp_Write;									//foCXo͏
p_funcConnectChk	cbp_ConnectChk;								//foCXڑ`FbN
p_funcReConnect		cbp_ReConnect;								//foCXĐڑ
p_funcMSGHandler	cbp_MSGHandler;								//bZ[Wnh[
p_funcWAIT			cbp_Wait;									//Jnҋ@֐
// T[rX֐
extern void ThreadAutoCycle(struct MYSTATE *state);
extern void ThreadConnectChk(struct MYSTATE *state);
extern void ThreadInService(IO_TRDINFO *trdInfo);
extern void ThreadOutService(IO_TRDINFO *trdInfo);
extern void KickInput(struct MYSTATE *state);
extern void KickOutput(struct MYSTATE *state);
extern int32_t CreateServiceTags(struct MYSTATE *state);
extern int32_t GetProperty(struct MYSTATE *state);
extern int32_t StartService(struct MYSTATE *state);
extern int32_t PauseService(struct MYSTATE *state);
extern int32_t InitService(struct MYSTATE *state);
extern int32_t KillService(struct MYSTATE *state);
extern void WarningMsg(int32_t position, int32_t reason);
extern void CreateInThreadInfo(WORD woID, IO_TRDINFO* trdInfo);
extern void CreateOutThreadInfo(WORD woID, IO_TRDINFO* trdInfo);
extern void UpdateIOThreadOpeTime(IO_TRDINFO* trdInfo, QWORD start, QWORD end);

extern void fnTagWriteStatus(uint8_t byStatus);						//T[rXCWP[^(Status)̒l
extern void fnTagWriteRun(BOOL boRun);								//T[rXCWP[^(Run)̒l
extern void fnTagWriteLive();										//T[rXCWP[^(Live)̒l
extern void fnTagWriteError(BOOL boErr);							//T[rXCWP[^(Error)̒l
extern void fnTagWriteDrvConnect(BOOL boConnect, DWORD errStatus);	//ڑԃtȌ
extern void fnTagWriteInThreadLastErr(WORD woID, DWORD errStatus);	//̓XbhŐVG[(.InThreadXX_LastErr)̒l
extern void fnTagWriteOutThreadLastErr(WORD woID, DWORD errStatus);	//o̓XbhŐVG[(.OutThreadXX_LastErr)̒l
extern void fnLog(const char* pServiceName, const char* pMode, const char * _Format, ...);
extern _inline QWORD GetPentiumCounter(void);
extern DWORD GetCPUSpeed(void);
extern double CalcTime(QWORD start, QWORD end);

extern void fnAddUserFunc();
extern void fnAddUserFunc_ConnectChk(p_funcConnectChk pFunc);
extern void fnAddUserFunc_ReConnect(p_funcReConnect pFunc);

// foCXŗLpR[obN֐
extern DWORD CB_INIT(EgFWdesc *desc, DWORD* errStatus);
extern DWORD CB_OPEN(EgFWdesc *desc, DWORD* errStatus);
extern DWORD CB_CLOSE(EgFWdesc *desc, DWORD* errStatus);
extern DWORD CB_READ(EgFWdesc *desc, WORD woID, uint64_t address, void* pData, long size, long bufsize, EGIOPORT *egio);
extern DWORD CB_WRITE(EgFWdesc *desc, WORD woID, uint64_t address, void* pData, long size, EGIOPORT *egio);
extern BOOL mycb_ConnectChk(EgFWdesc *desc, DWORD* errStatus);
extern DWORD mycb_ReConnect(EgFWdesc *desc, DWORD* errStatus);
extern int32_t CB_MSGHandler(const char* sender, int32_t msgno, void *param);

extern DWORD CB_WAIT(EgFWdesc *desc, DWORD* errStatus);

///
/// e`I
//////////////////////////////////////////////////////////////////////////////