/*****************************************************************************
* Poll1.c - |[Ô߂̃W[ Poll1
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>

#include <egAPI.h>			// RT-edge system API

#include "Test_eWrapCANIF.h"
#include "../eWrapCANIF/eWrapCANIF.h"

/* ޱȕ։ */
#define EG_TAG_READ(str, var) (EgTagRead((str), &(var), sizeof(var)), (var))

/*****************************************************************************
* FUNCTION:		Poll1
* DESCRIPTION:
*   |[OXbh Poll1
\*****************************************************************************/
void				Poll1(
	void*				param)
{
	/* 񑗎M{\莞 */
	QWORD next_recv_t;

	gInit.last_recv_id = -1;

	// {XbhĂ邱Ƃo^
	gInit.htPoll1	= GetRtThreadHandles(THIS_THREAD);

	// XbhJ^OAs͖
	Catalog(NULL_RTHANDLE, gInit.htPoll1, "TPoll1");

	/* Mٰ */
	next_recv_t = knGetKernelTime(NULL);
	next_recv_t += gInit.recv_wait;
	while (!gInit.bShutdown)
	{
		QWORD curr_t = knGetKernelTime(NULL);

		/* M͎M̂ */
		if (gInit.enable_recv) {

			/* M */
			if (curr_t >= next_recv_t) {
				for (int i = 0; i < gInit.slave_count; i++) {
					if (CAN_Read(i, NULL, NULL, NULL, NULL, NULL) > 0) {
						uint32_t can_id;
						bool ext;
						bool rtr;
						int length;
						uint8_t data[8];

						int ret = CAN_Read(i, &can_id, &ext, &rtr, &length, data);

						printf("[R:%02X] ID=0x%08X(%s), remain=%d, %s", i, can_id, ext ? "EXT" : "STD", ret, rtr ? "RTR" : "");
						if (length) {
							printf("{ ");
							for (int j = 0; j < length; j++) printf("0x%02X, ", data[j]);
							printf("}");
						}
						printf("\n");

						if (gInit.enable_recv_seq_chk && can_id != (gInit.last_recv_id + 1)) {
							printf("[R:%02X] !!SEQUENCE ERROR: ID=0x%08X, Expected=0x%08X\n", i, can_id, gInit.last_recv_id + 1);
						}

						gInit.last_recv_id = can_id;
					}
				}
				next_recv_t += gInit.recv_wait;
			}

		}
		else {
			/*  */
			next_recv_t += gInit.recv_wait;
		}
		
		/* ԑ҂ */
		if (curr_t < next_recv_t) knRtSleep(next_recv_t - curr_t);
	}

	// {Xbh̏Iʒm
	gInit.htPoll1	= NULL_RTHANDLE;

	printf("Stop: Poll1\n");
}
