/*****************************************************************************
* SendServer.c - XbhW[ SendServer
\*****************************************************************************/

#include <stdio.h>
#include <rt.h>
#include <conio.h>
#include <io.h>
#include <egAPI.h>			// RT-edge system API

#include "Test_eWrapCANIF.h"
#include "../eWrapCANIF/eWrapCANIF.h"

/* ޱȕ։ */
#define EG_TAG_READ(str, var) (EgTagRead((str), &(var), sizeof(var)), (var))

/*****************************************************************************
* FUNCTION:   api_test
*
* APIُný
\*****************************************************************************/
void api_test() {

	union {
		uint64_t q;
		uint8_t b[8];
	} data;
	bool rtr;
	int len;
	int ret;

	/* Writë */
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = false), (len = -1), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = false), (len = 9), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = false), (len = 0x7FFFFFFF), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = false), (len = 0x80000000), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = true), (len = -1), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = true), (len = 1), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);
	ret = CAN_Write(gInit.send_slave, 0x123, false, (rtr = true), (len = 8), data.b);
	printf("[T:%02X] ý: CAN_Write(rtr = %s, length = %d) : %d\n", gInit.send_slave, rtr ? "true" : "false", len, ret);

}

/*****************************************************************************
* FUNCTION:   set_config
*
* ݒl
\*****************************************************************************/
void set_config() {
	
	char retc;
	int ret;
	
	/* @memo Ȃ%ĉƂ؂蕶ǂޓɂȂĂc */
	#define GET_Y_N	(scanf(" %c", &retc), printf("-> %c\n", retc), ((retc == 'Y' || retc == 'y') ? TRUE : FALSE))
	#define GET_INT	(scanf("%d", &ret), printf("-> %d\n", ret), ret)

	/* How many files(0-15)? */
	printf("recv_wait(0- [ticks])?");
	gInit.recv_wait = GET_INT;

	printf("enable_send(y/n)?");
	if ((gInit.enable_send = GET_Y_N)) {

		printf("send_slave(0- )?");
		gInit.send_slave = GET_INT;

		printf("send_lim(0- )?");
		gInit.send_lim = GET_INT;

		printf("send_wait / 128 frames(0- [ticks])?");
		gInit.send_wait = GET_INT;

		printf("enable_send_log(y/n)?");
		gInit.enable_send_log = GET_Y_N;
		printf("enable_rtr(y/n)?");
		gInit.enable_rtr = GET_Y_N;
		printf("enable_ext(y/n)?");
		gInit.enable_ext = GET_Y_N;

	}
	else {
		printf("enable_recv_seq_chk(y/n)?");
		gInit.enable_recv_seq_chk = GET_Y_N;
	}

	#undef GET_Y_N
	#undef GET_INT
}

/*****************************************************************************
* FUNCTION:   ServerSendServer
*
* f[^[{bNX̃Xbh SendServer.
\*****************************************************************************/
void ServerSendServer(void* param)
{
	WORD			wActual;
	BYTE			byMessage[128];
	RTHANDLE		hSendServer;

	// TODO: tOK؂łȂΕύXĂ
	hSendServer	= CreateRtMailbox(DATA_MAILBOX | FIFO_QUEUING);
	if (BAD_RTHANDLE == hSendServer)
	{
		Fail("Cannot create data mailbox SendServer");
		return;
	}
	if (!Catalog(NULL_RTHANDLE, hSendServer, "SendServer"))
	{
		Fail("Cannot catalog data mailbox SendServer");
		return;
	}

	// {XbhĂ邱Ƃo^
	gInit.htSendServer	= GetRtThreadHandles(THIS_THREAD);

	// XbhJ^OAs͖
	Catalog(NULL_RTHANDLE, gInit.htSendServer, "TSendServer");

	/* ݒl۰ */
	set_config();

	/* IIO۰ނĂȂꍇ́AʐMs\ł邱Ƃ̎pӰނƂȂ */
	{
		int val = kbhit();
		if (EG_TAG_READ("SERVICE.ECAT", val) == 0) {
			printf("N҂c(r: ƭٽāAp: āȂ: I)\n");

			/* N҂ٰ */
			while (!gInit.bShutdown)
			{
				bool run = false;
				CAN_GetDriverState(&run, NULL, &gInit.slave_count);
				if (run) break;

				/* ƭٽėvĂ΁A΂Ă݂ */
				if (kbhit() != val) {
					DWORD pdwCount;
					int ret = ReadRtConsole(&val, 1, &pdwCount);
					printf("!\n");
					if (val == 'r') {
						if ((ret = CAN_ManualStart()) < 0) printf("Fail: CAN_ManualStart() : 0x%08X\n", ret);
					} else if (val == 'p') {
						break;
					} else {
						goto fin;
					}
					val = kbhit(); /* @memo Ȃޯ̧رȂAM邱ƂłȂBݼĂŎgɂ͖Ȃ߁AU(Ǘ̈悪TLSۂ̂ł̗݂cBҲݽگނ炵gȂƂ)B */
				}

				RtSleep(100);
			}

			/* ڰޗ */
			printf("ڰސ: %d\n", gInit.slave_count);

			/* MJn */
			gInit.enable_recv = TRUE;

		} else {
			printf("I-I/Os݁cӰ\n");
		}
	}

	while (!gInit.bShutdown)
	{
		/* ǑΘb^ݿقŗǂ񂶂? Ƃ */
		char retc;
cont:
		printf("--- g ---\n");
		printf("c: config\n");
		printf("s: send\n");
		printf("t: APIُnďoeXg\n");
		printf("r: MV[PX`FbN Zbg\n");
		printf("?: ԕ\\n");
		printf("b: M~(ubN)\n");
		printf("a: MĊJ\n");
		printf("q: quit\n");

		scanf(" %c", &retc), printf("-> %c\n", retc);
		switch (retc) {
			case 'c': {
				set_config();
				break;
			}
			case 's': {
				/* Mٰ */
				QWORD next_send_t;		/* 񑗎M{\莞 */
				int send_count = 0;
				int max_send_remain = 0;

				next_send_t = knGetKernelTime(NULL);
				while (!gInit.bShutdown && gInit.enable_send && send_count < gInit.send_lim) {

					QWORD curr_t = knGetKernelTime(NULL);

					/* M */
					if (curr_t >= next_send_t) {
						static int can_id = 0;
						static union {
							uint64_t int64;
							uint8_t raw[8];
						} data = { 0 };
						int len;
						int ret;

						for (len = 0; data.raw[len]; len++);

						ret = CAN_Write(gInit.send_slave, can_id, gInit.enable_ext, gInit.enable_rtr, gInit.enable_rtr ? 0 : len, data.raw);
						if (gInit.enable_send_log) printf("[S:%02X] ID=0x%08X(%s), remain=%d,%s length = %d\n", gInit.send_slave, can_id, gInit.enable_ext ? "EXT" : "STD", ret, gInit.enable_rtr ? " RTR," : "", gInit.enable_rtr ? 0 : len);

						data.int64++;
						can_id++;
						send_count++;

						if (!(send_count % 128)) next_send_t += gInit.send_wait;

						if (max_send_remain < ret) max_send_remain = ret;

						if (send_count >= gInit.send_lim) {
							/* Ō̑MBޯ̧c̍őlo͂ */
							printf("[S:%02X] max_remain=%d\n", gInit.send_slave, max_send_remain);
						}
					}

					/* ԑ҂ */
					if (curr_t < next_send_t) knRtSleep(next_send_t - curr_t);
				}
				break;
			}
			case 't': {
				api_test();
				break;
			}
			case 'r': {
				gInit.last_recv_id = -1;
				break;
			}
			case '?': {
				int ret;
				bool is_running; bool error; unsigned int instance_count = 10;
				ret = CAN_GetDriverState(&is_running, &error, &instance_count);
				printf("[i   ] is_running=%d, error=%d, instance_count=%d (ret=0x%08X)\n", (int)is_running, (int)error, instance_count, ret);

				for (int i = 0; i < (int)instance_count; i++) {
					bool tx_overrun, rx_overrun;
					struct CAN_SLAVE_DEVICE_STATE device_state;

					ret = CAN_GetOverrunState(i, &tx_overrun, &rx_overrun);
					printf("[i:%02X] tx_overrun=%d, rx_overrun=%d (ret=0x%08X)\n", i, (int)tx_overrun, (int)rx_overrun, ret);

					ret = CAN_GetDeviceState(i, &device_state);
					printf("       node_state=%d, error=%d, can_state=%d, rx_error_count=%d, tx_error_count=%d, \n", 
						(int)device_state.node_state,
						(int)device_state.error,
						(int)device_state.can_state,
						(int)device_state.rx_error_count,
						(int)device_state.tx_error_count);
					printf("       diag_flag=%d, node_diag_flag=%d (ret=%d)\n",
						(int)device_state.diag_flag,
						(int)device_state.node_diag_flag,
						ret);
				}
				break;
			}
			case 'b': {
				gInit.enable_recv = FALSE;
				break;
			}
			case 'a': {
				gInit.enable_recv = TRUE;
				break;
			}
			case 'q': {
				TerminateRtProcess(NULL_RTHANDLE, 0, 0); /* ҲݽگނCleanupŖ{گނ̎s҂sĂׁA҂Ȃ */
				goto fin;
			}
			default: {
				printf("????\n");
				goto cont;
			}
		}
		printf("Ok.\n");
	}
fin:
	// {Xbh̏Iʒm
	gInit.htSendServer	= NULL_RTHANDLE;
}
