/*****************************************************************************
* FILE NAME:    Test_eWrapCANIF.c - CvOW[
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <rt.h>

#include "Test_eWrapCANIF.h"

// O[oϐ
RTHANDLE			hRootProcess;
DWORD				dwKtickInUsecs;
INIT_STRUCT			gInit;

/*****************************************************************************
* FUNCTION:     main
*
* DESCRIPTION:
*  ̓CvOW[ł
*  LAׂẴXbhAׂẴIuWFNg𐶐܂
*  main֐I܂ł̊ԃvZXƂđ݂AIɂׂ̂Ă͍폜܂
\*****************************************************************************/
int					main(int argc, char* argv[])
{
	SYSINFO			sysinfo;
	EVENTINFO		eiEventInfo;
#ifdef _DEBUG
	fprintf(stderr, "Test_eWrapCANIF started\n");
#endif

	// [gvZX擾is܂j
	hRootProcess	= GetRtThreadHandles(ROOT_PROCESS);

	// W[\̂NA܂
	memset(&gInit, 0, sizeof(gInit));
	gInit.state		= BEFORE_INIT;

	/*  */
	{
		gInit.enable_send = FALSE;			/* MýĂ邩ǂ */
		gInit.enable_rtr = FALSE;			/* ӰڰёMýӰނ邩ǂ */
		gInit.enable_ext = FALSE;			/* MýĂgڰтŎ{邩ǂ */
		gInit.enable_recv_seq_chk = FALSE;	/* Mݽ邩ǂ(ID/ް0̘AԂł邱Ƃ) */
		gInit.enable_send_log = FALSE;		/* M۸ޏo͂sǂ */
		gInit.send_slave = 0;				/* MΏ۽ڰ */
		gInit.send_wait = 1;				/* 128ڰёM(write)ɑ}wait(è) */
		gInit.recv_wait = 1000;				/* 1ڰюM(read)ɑ}wait(è) */
		gInit.send_lim = 0;					/* M(ȏ㑗Ȃ) */
	}

	// ჌xeBbNli}CNbj擾܂
	if (!CopyRtSystemInfo(&sysinfo))
		Fail("Cannot copy system info");
	dwKtickInUsecs	= 10000 / sysinfo.KernelTickRatio;
	if (dwKtickInUsecs == 0)
		Fail("Invalid low level tick length");

	// vZXővCIeB𒲐܂(s͖)
	// TODO adjust 2Ԗڂ̃p[^𐔒lIɏ邱Ƃł荂vCIeBXbhe܂
	SetRtProcessMaxPriority(NULL_RTHANDLE, 150);

	// CXbh(̊֐)̃nh擾܂
	gInit.hMain		= GetRtThreadHandles(THIS_THREAD);
	gInit.state		= INIT_BUSY;

	// XbhJ^O݂܂As͖܂
	Catalog(NULL_RTHANDLE, gInit.hMain, "TMain");

	// [gvZXɖ{vZXJ^O܂
	if (!Catalog(hRootProcess, GetRtThreadHandles(THIS_PROCESS), "Test_eWrapCA"))
		Fail("Cannot catalog process name");
	gInit.bCataloged = TRUE;

	// create mailbox, semaphore and message queue threads
	if (BAD_RTHANDLE == CreateRtThread(192, (LPPROC)ServerSendServer, 4096, 0))
		Fail("Cannot create thread for SendServer");

	// |[OXbh𐶐܂
	if (BAD_RTHANDLE == CreateRtThread(224, (LPPROC)Poll1, 4096, 0))
		Fail("Cannot create poll thread Poll1");

	// Ƃ܂
	gInit.state		= INIT_DONE;
#ifdef _DEBUG
	fprintf(stderr, "Test_eWrapCANIF finished initialization\n");
#endif

	// Cxgҋ@܂
	while (RtNotifyEvent(RT_SYSTEM_NOTIFICATIONS | RT_EXIT_NOTIFICATIONS,
		WAIT_FOREVER, &eiEventInfo))
	{
		switch(eiEventInfo.dwNotifyType)
		{
		case TERMINATE:
			// TODO: {vZX͏I܂
			// N[Abv܂
			Cleanup();  // ߂邱Ƃ͂܂

		case NT_HOST_UP:
			// TODO: RTNCAgɂNTzXg̕AΉ
			break;

		case NT_BLUESCREEN:
			// TODO: Windows̃u[XN[oΉ
			break;

		case KERNEL_STOPPING:
			// TODO: INtimeJ[lT[rX~Ή
			break;

		case NT_HOST_HIBERNATE:
			// TODO: WindowszXg̋x~ԈڍsΉ
			break;

		case NT_HOST_STANDBY:
			// TODO: WindowszXg̃X^oCԈڍsΉ
			break;
			break;

		case NT_HOST_SHUTDOWN_PENDING:
			// TODO: WindowszXg̃Vbg_EΉ
			break;
		}
	}
	Fail("Notify failed");
	return 0;
}
