//
//  RSI-CAN-E
//
//   RT-edge IIO(R) CAN Wrapper
//
//   Copyright (C) 2025 Micronet Co. All rights reserved.
//

#include <rt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../EgCommon/edgeCommon.h"

/* @memo exportwͺ߲׵߼݂̕Őݒ肵Ă */
#include "eWrapCAN.h"

//
//{RSLŎgp^O`
//
/* 󋵒ʒmp */
char PROP_MYSERV_TXCOUNT [EG_MAX_TAGNAME + 1] = { 0 };
char PROP_MYSERV_RXCOUNT [EG_MAX_TAGNAME + 1] = { 0 };
/* Žðݼ޹ǂ(RT-edgełƂĒ۰ނӼޭقł͂Ȃ߁A悤Ȃ͎̂) */
char PROP_MYSERV_STATUS  [EG_MAX_TAGNAME + 1] = { 0 };
char PROP_MYSERV_ERROR   [EG_MAX_TAGNAME + 1] = { 0 };
char PROP_MYSERV_RUN     [EG_MAX_TAGNAME + 1] = { 0 };
char PROP_MYSERV_LIVE    [EG_MAX_TAGNAME + 1] = { 0 };
/* œèǂ */
char PROP_MYSERV_MODE    [EG_MAX_TAGNAME + 1] = { 0 };
#define	MODE_AUTO		1			// oTCN
#define	MODE_SEMIAUTO	2			// ̓TCN{o̓f}h
#define	MODE_MANUAL		3			// o̓f}h
#define	DEFAULT_MODE	MODE_AUTO
char PROP_MYSERV_PRIORITY[EG_MAX_TAGNAME + 1] = { 0 };
#define	DEFAULT_PRIO		150		/* @memo I-I/O(R)̏oͽگ̫Ēl + 1 */
#define	MAX_PRIO			254
#define	MIN_PRIO			1
char PROP_MYSERV_OVR_CTRL[EG_MAX_TAGNAME + 1] = { 0 };
#define	OVR_CTRL_STOP		0		// ʐMگނ~
#define	OVR_CTRL_RUN		1		// ʐMگނ~AÂް㏑Ă
#define	OVR_CTRL_DEFAULT	OVR_CTRL_RUN
/* ECATgpQ / ؗp */
char PROP_MYSERV_NODENAME[EG_MAX_TAGNAME + 1] = { 0 };		// m[hݒ^O
char PROP_MYSERV_DRV_CONNECT[EG_MAX_TAGNAME + 1] = { 0 };	// ʐMڑ


//------------------------------------------------------------------------------
// T[rX(ǂ)`
//------------------------------------------------------------------------------
struct MYSTATE
{
	uint32_t	TxCount;		// CWP[^.Mt[
	uint32_t	RxCount;		// CWP[^.Mt[
	
	uint8_t		InitStatus;		// T[rX(0:, 1:, 2:(RunMς), 3:)
	uint8_t		Status;			// CWP[^.GbWVXeڑ
	bool		Error;			// CWP[^.T[rXُ
	bool		Run;			// CWP[^.T[rXs
	uint32_t	Live;			// CWP[^.T[rXsJE^
	
	uint8_t		Mode;			// vpeB.T[rXs[h
	uint8_t		Priority;		// vpeB.T[rXvCIeB
	uint8_t		OverrunCtrl;	// vpeB.MI[o̓(0:T[rX~A1:Âf[^㏑ēp)

	/* pp(گފԒʐM) */
	bool		req_dispose;	// Pv(ʐMٰ߂ɓOɒʐMگނI邽߂̂)
	bool		ack_dispose;	// trueœPv󂯕tƂ
	BOOL		is_connected;	// ŌɌĂяoꂽHiConnectChk()̌

	/* I-I/O(R)è */
	char 		node_name[EG_MAX_TAGADDRESS + 1];	// vpeB.m[h
};

/* ލXVp */
#define EG_TAG_WRITE(str, var, new_val)		(EgTagWrite(str, ((var) = (new_val),/* @memo ωZq */ &(var)), sizeof(var)))
#define EG_TAG_WRITE_E(entry, var, new_val)	(EgTagWriteByEntry(entry, ((var) = (new_val),/* @memo ωZq */ &(var)), sizeof(var)))

//------------------------------------------------------------------------------
// Mݸޯ̧
//------------------------------------------------------------------------------
/* FIFO` */
#define FIFO_DATA_COUNT	(1024)
#include "fifo.h"

//------------------------------------------------------------------------------
// ޲ײނ̊Ǘ
//------------------------------------------------------------------------------
/* ײނ̲ݸٰ */
#include "drv_BECKHOFF_EL6751.h"

/* @todo ڰߕʑM֐Aaɂdg */

//----------------------------------------------------------------------------
// macro : Get function pointer
//----------------------------------------------------------------------------
#define E$(PMSG, ...)		printf("E$EWRAPCAN.C""[%05d] "PMSG, __LINE__, __VA_ARGS__);
#define LOAD_API(err_code, handle, pfn, name)                       \
	*((LPPROC*)&(pfn)) = GetRtProcAddress(handle, name);            \
	if( (pfn) == NULL ) {                                           \
		E$("GetRtProcAddress( %s ) failed. Status[%08Xh]\n", name, (err_code | (WORD)GetLastRtError())); \
	}	

//------------------------------------------------------------------------------
// RSI-ECATͯނɈˑȂ߂̏`
//------------------------------------------------------------------------------
#define ER_EHAPI_OK		(0x0000)
#define EHHANDLE		void*
#define MST_OPERATIONAL	(0x08)
typedef struct TAG_SLAVE_DETAIL {
	
	DWORD dwSize;				// SLAVE_DETAIL \̃TCY
	WORD woAlias;				// GCAXԍ
	WORD woCategoryCount;		// Categorys \̎gp
	
	struct TAG_CATEGORYS {
		WORD woChannel;			// Jn`lԍ
		WORD woChannelCount;	// `l
		WORD woCategoryID;		// JeSID
	} Categorys[4];
	
	DWORD dwInstance;			// CX^Xԍ
	DWORD dwVendorID;			// x_[ID
	DWORD dwProductCode;		// v_NgR[h
	DWORD dwRevisionNo;			// rWio[
	DWORD dwSerialNo;			// VAio[
	DWORD dwPhysicalAddr;		// tBWJAhX
	DWORD dwAutoIncAddr;		// CNgAhX
	DWORD dwStatusBit;			// X[uXe[^Xrbg
	DWORD dwViosInBaseOffset;	// VIOS IN x[XItZbg
	DWORD dwViosInSize;			// VIOS IN TCY(byte)
	DWORD dwViosOutBaseOffset;	// VIOS OUT x[XItZbg
	DWORD dwViosOutSize;		// VIOS OUT TCY(byte)
	DWORD dwDCEnabled;			// DCݒ (0:, 0ȊO:L)
	DWORD dwSlaveNo;			// X[uڑԍ
	
} SLAVE_DETAIL; 

//------------------------------------------------------------------------------
// CANʐM ܰر
//------------------------------------------------------------------------------
struct WORK
{
	/* RSI-ECAT  */
	EHHANDLE h_eh;
	
	/* ڰ(EL6751)ݽݽ */
	int slave_count;
	
	/* ڰޏ / ܰ */
	struct {
		/* ڰ(EL6751)ߏ(g̫ϯđΉI/Fǂ) */
		/* `l͈ȉ(`l̏ꍇ͖ƂĈ) */
		#define CAN_COMM_SLAVE_FORMAT_ID_STD	(1)	/* W̫ϯ(11bit ID)p */
		#define CAN_COMM_SLAVE_FORMAT_ID_EXT	(2)	/* g̫ϯ(29bit ID)Ή */
		uint8_t format_id;
		
		/* ڰ޲ݽݽ̐ڑԍ */
		int slave_id;

		/* ڰ޲ݽݽ VIOS̈擪ڽ */
		struct EL6751_VIOS *vios_in, *vios_out;

		/* ڰ޲ݽݽ FIFO */
		void *fifo_in, *fifo_out;

		/* ڰ޲ݽݽ ޯ̧׸ /  */
		void *is_ovr_fifo_in_tag, *is_ovr_fifo_out_tag;
		bool is_ovr_fifo_in, is_ovr_fifo_out;

	} *slave;
	
} work;

//----------------------------------------------------------------------------
// [Jϐ`
//----------------------------------------------------------------------------
/* ʑDLL */
static RTHANDLE s_hLowerWrapperLib = NULL_RTHANDLE;
static RTHANDLE s_hEhAPILib = NULL_RTHANDLE;

/* گ */
static RTHANDLE s_hThread_CAN_Comm = NULL_RTHANDLE;

/* ޽(ǂ) */
static struct MYSTATE MyState;		// Xe[^X֘A


//----------------------------------------------------------------------------
// ʑ ذ߲Ċi[`
//----------------------------------------------------------------------------
static DWORD (*Lower_HiInit)(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus);
static DWORD (*Lower_HiOpen)(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);
static DWORD (*Lower_HiClose)(RSIHANDLE hRsi, DWORD* dwAPIStatus);
static DWORD (*Lower_HiRead)(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus);
static DWORD (*Lower_HiWrite)(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus);
static DWORD (*Lower_HiReConnect)(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus);
static BOOL (*Lower_HiConnectChk)(void* ptr, DWORD dwTimeout, DWORD* dwErrorStatus);
static DWORD (*Lower_HiWait)(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus);

static WORD (*__EhGetEhNodeStatus)(char *NodeName, DWORD dwTimeout);
static EHHANDLE (*__EhOpen)(char *NodeName, WORD *pStatus);
static WORD (*__EhClose)(EHHANDLE ehApi);
static WORD (*__EhFindSlave)(EHHANDLE ehApi, SLAVE_DETAIL *pSlaveDetail);
static WORD (*__EhGetViosInAddress)(EHHANDLE ehApi, void **ppAddr, DWORD *pdwSize);
static WORD (*__EhGetViosOutAddress)(EHHANDLE ehApi, void **ppAddr, DWORD *pdwSize);
static WORD (*__EhGetState)(EHHANDLE ehApi, WORD *pRqState,	WORD *pState);
static WORD (*__EhReadOD)(EHHANDLE ehApi, WORD woSlaveNo, WORD woObjIndex, BYTE bySubIndex, void *pRData, BYTE bySize);
static WORD (*__EhWriteOD)(EHHANDLE ehApi, WORD woSlaveNo, WORD woObjIndex, BYTE bySubIndex, void *pWData, BYTE bySize);
static WORD (*__EhWaitForCyclic)(EHHANDLE ehApi, DWORD dwTimeOut);
static WORD (*__EhCancelWaitForCyclic)(EHHANDLE ehApi, RTHANDLE hThread);

/*****************************************************************************
* FUNCTION:			fnServiceTagNameCreate
* DESCRIPTION:		^O/J^O𐶐
\*****************************************************************************/
void fnServiceTagNameCreate()
{
	/* 󋵒ʒmp */
	sprintf(PROP_MYSERV_TXCOUNT,     "SERVICE.%s.CAN.TxCount",     ServiceRealName);
	sprintf(PROP_MYSERV_RXCOUNT,     "SERVICE.%s.CAN.RxCount",     ServiceRealName);
	
	/* Žðݼ޹ǂ(RT-edgełƂĒ۰ނӼޭقł͂Ȃ߁A悤Ȃ͎̂) */
	sprintf(PROP_MYSERV_STATUS,      "SERVICE.%s.CAN.Status",      ServiceRealName);
	sprintf(PROP_MYSERV_ERROR,       "SERVICE.%s.CAN.Error",       ServiceRealName);
	sprintf(PROP_MYSERV_RUN,         "SERVICE.%s.CAN.Run",         ServiceRealName);
	sprintf(PROP_MYSERV_LIVE,        "SERVICE.%s.CAN.Live",        ServiceRealName);
	
	/* œèǂ */
	sprintf(PROP_MYSERV_MODE,        "SERVICE.%s.CAN.Mode",        ServiceRealName);
	sprintf(PROP_MYSERV_PRIORITY,    "SERVICE.%s.CAN.Priority",    ServiceRealName);
	sprintf(PROP_MYSERV_OVR_CTRL,    "SERVICE.%s.CAN.OverrunCtrl", ServiceRealName);

	/* ECATgpQ / ؗp */
	sprintf(PROP_MYSERV_NODENAME,    "SERVICE.%s.NodeName",        ServiceRealName);	// m[hݒ^O
	sprintf(PROP_MYSERV_DRV_CONNECT, "SERVICE.%s.Connected",       ServiceRealName);	// ʐMڑ
}

//----------------------------------------------------------------------------
// CANʐMگ
//----------------------------------------------------------------------------
void Thread_CAN_Comm(struct MYSTATE *state)
{
	bool on_cancel = false;
	WORD ret;
	
	/* @warning Đڑ͍lȂ */
	
	/* ޽NƂʒm */
	EG_TAG_WRITE(PROP_MYSERV_STATUS, MyState.Status, 1);
	
	/* ʑڑJn҂ */
	/* @memo RSI-ECAT HI APIOpen()́AIEhOpen()ĂяoĂ邪A */
	/*       گނEhOpen()sEhOpen()ĂяoƁA㔭Ăяos(ER_EHAPI_CONFLICT)B */
	/*       ̂߁AɉʑOpen()mɏI点ĂA{گނEhOpen()s悤ɂ */
	for (;;){
		BOOLEAN connected = FALSE;
		if (EgTagRead(PROP_MYSERV_DRV_CONNECT, &connected, sizeof(connected)) == EDGE_SUCCESS && connected){
			break;
		}
		if (MyState.req_dispose) goto fin;
		
		/* @todo ҂Ԓ */
		RtSleep(200);
	}
	/* @memo ECATConnected́AOpenɕKTRUEƂȂ(̒iKłHiConnectChkĂ΂Ȃ)B瑤ɑB */
	MyState.is_connected = TRUE;
	
	/* N҂ */
	/* @memo ʑ̐ڑ҂悤ɂ̂ŁAȂĂǂ */
	if ((ret = __EhGetEhNodeStatus(state->node_name, WAIT_FOREVER)) != ER_EHAPI_OK){
		E$("EhGetEhNodeStatus() failed. Status[%04Xh]\n", ret);
		EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
		return;
	}
	
	/* ڑ */
	if ((work.h_eh = __EhOpen(state->node_name, &ret)) == NULL){
		E$("EhOpen() failed. Status[%04Xh]\n", ret);
		EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
		return;
	}
	
	/* ڰޗ */
	{
		SLAVE_DETAIL sd;
		int i = 0;

		sd.dwSize = sizeof(sd);
		sd.dwVendorID = 0x00000002/* BECKHOFF */;
		sd.dwProductCode = 0x1A5F3052/* EL6751 */;

		/* ܂͌m肳 */
		for (;;) {
			sd.dwInstance = i;
			if (__EhFindSlave(work.h_eh, &sd) != ER_EHAPI_OK) {
				break;
			}
			i++;
		}
		work.slave_count = i;

		/* Ɉˑؿ쐬 */
		{
			int slave_mem_size = sizeof(*work.slave) * work.slave_count;

			if (work.slave_count == 0) {
				/* ʐM\ȽڰނȂꍇłN̂͂ł悤ɂ */
				/* (悤͗̈滲ނ1޲ĈȏƂȂ悤ɂBۂ̓ǂݏ͍sȂB) */
				Log$(ServiceRealName, EG_LOG_WRN, "CAN: Can't find EL6751\n");
				slave_mem_size++;
			}

			/* @memo ۾I܂ŕێ */
			if (!(work.slave = malloc(slave_mem_size))) {
				E$("malloc() / AllocateRtMemory() failed. Status[%08Xh]\n", GetLastRtError());
				EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
				return;
			}
		}

		/* VIOS̈ڽ擾 / ̪ʔ(gIDΉǂ) / ݽݽɑΉނ̍쐬 */
		{
			/* ލ쐬pܰر */
			uint32_t ret_d, val_buf;

			/* ލ쐬p APIďoEװ */
			#define TARGET_NAME	(prop_buf)
			#define EG_API(func, ...) \
				if ((ret_d = (func)(__VA_ARGS__)) != EDGE_SUCCESS) { \
					E$(#func "(%s) failed. Status[%08Xh]\n", TARGET_NAME, ret_d); \
					EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE); \
					return; \
				} \
			
			/* VIOSرp */
			void *vios_in, *vios_out;
			DWORD vios_size/* ǂݎ̂ėp */;

			/* ްڽ擾 */
			if ((ret = __EhGetViosInAddress(work.h_eh, &vios_in, &vios_size)) != ER_EHAPI_OK) {
				E$("EhGetViosInAddress() failed. Status[%04Xh]\n", ret);
				EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
				return;
			}
			if ((ret = __EhGetViosOutAddress(work.h_eh, &vios_out, &vios_size)) != ER_EHAPI_OK) {
				E$("EhGetViosOutAddress() failed. Status[%04Xh]\n", ret);
				EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
				return;
			}

			/* ٰ */
			for (i = 0; i < work.slave_count; i++) {

				sd.dwInstance = i;

				if ((ret = __EhFindSlave(work.h_eh, &sd)) != ER_EHAPI_OK) {
					/* قǗ񋓂ł͂̽ڰނɱłȂB͂ */
					E$("EhFindSlave(i = %d) failed. Status[%04Xh]\n", i, ret);
					EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, TRUE);
					return;
				}

				/* ڰޔԍ(APIŎg) */
				work.slave[i].slave_id = sd.dwSlaveNo;

				/* ڽݒ */
				work.slave[i].vios_in = (void *)((intptr_t)vios_in + sd.dwViosInBaseOffset);
				work.slave[i].vios_out = (void *)((intptr_t)vios_out + sd.dwViosOutBaseOffset);

				/* ̪ʔ */
				/* ̂ƂAVIOS̻̈ނŔfĂ */
				/* m̻ނɂȂĂꍇ́A{ׯ߂ł̐ΏۂƂĈȂ(AM̓ǂݎ̂Ă͍s) */
				if (
					(sd.dwViosInSize == (sd.dwViosOutSize + sizeof(struct EL6751_VIOS_IN_STATE))) &&
					(sd.dwViosOutSize == sizeof(struct EL6751_VIOS_STD))
					) {
					work.slave[i].format_id = CAN_COMM_SLAVE_FORMAT_ID_STD;
				}
				else if (
					(sd.dwViosInSize == (sd.dwViosOutSize + sizeof(struct EL6751_VIOS_IN_STATE))) &&
					(sd.dwViosOutSize == sizeof(struct EL6751_VIOS_EXT))
					) {
					work.slave[i].format_id = CAN_COMM_SLAVE_FORMAT_ID_EXT;
				}
				else {
					/* I/F */
					Log$(ServiceRealName, EG_LOG_WRN, "CAN: Unsupport VIOS size: [%d, in= %d(rq: %d), out = %d(rq: %d or %d)]\n", i, sd.dwViosInSize, sizeof(struct EL6751_VIOS_IN_STATE) + sd.dwViosOutSize, sd.dwViosOutSize, sizeof(struct EL6751_VIOS_STD), sizeof(struct EL6751_VIOS_EXT));
					Log$(ServiceRealName, EG_LOG_WRN, "CAN: sizeof(struct CAN_COMM_DATA_EL6751_STD) = %d, [10] = %d, ofs = %d, %d\n", sizeof(struct CAN_COMM_DATA_EL6751_STD), sizeof(work.slave[0].vios_in->data.std), offsetof(struct CAN_COMM_DATA_EL6751_STD, head), offsetof(struct CAN_COMM_DATA_EL6751_STD, data));
					Log$(ServiceRealName, EG_LOG_WRN, "CAN: sizeof(struct CAN_COMM_DATA_EL6751_EXT) = %d, [10] = %d, ofs = %d, %d, %d\n", sizeof(struct CAN_COMM_DATA_EL6751_EXT), sizeof(work.slave[0].vios_in->data.ext), offsetof(struct CAN_COMM_DATA_EL6751_EXT, length), offsetof(struct CAN_COMM_DATA_EL6751_EXT, head), offsetof(struct CAN_COMM_DATA_EL6751_EXT, data));
					work.slave[i].format_id = 0;
				}
				Log$(ServiceRealName, EG_LOG_DBG, "CAN: EL6751[%d] format type = [%02Xh]\n", i, work.slave[i].format_id);

				/* c̏ */
				work.slave[i].is_ovr_fifo_in = work.slave[i].is_ovr_fifo_out = false;

				/* ލ쐬 */
				/* @todo ܂ƐłȂ */
				{
					uint16_t is_link;
					char prop_buf[EG_MAX_TAGNAME + 1], reg_name[EG_MAX_TAGNAME + 1];

					/* ڰޯ̧(FIFO)BAݸނɂȂꍇʹװ(ޯ̧ɓĔj󂷂\邽) */
					{
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_TX_FIFO_TAG_NAME, i);
						EG_API(EgTagCreateFIFO, prop_buf, sizeof(struct CAN_COMM_DATA_EL6751_EXT), FIFO_DATA_COUNT, false, "RSI-CAN-E Tx Frame FIFO", reg_name, sizeof(reg_name), &is_link);
						EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_out, sizeof(work.slave[i].fifo_out));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_RX_FIFO_TAG_NAME, i);
						EG_API(EgTagCreateFIFO, prop_buf, sizeof(struct CAN_COMM_DATA_EL6751_EXT), FIFO_DATA_COUNT, false, "RSI-CAN-E Rx Frame FIFO", reg_name, sizeof(reg_name), &is_link);
						EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].fifo_in, sizeof(work.slave[i].fifo_in));
					}

					/* 񋟗pނ͂̏Œlݒ肷 */
					{
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_TX_FIFO_OVR_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtBoolean, "", "RSI-CAN-E Tx Frame FIFO Overrun");
						EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].is_ovr_fifo_out_tag, sizeof(work.slave[i].is_ovr_fifo_out_tag));
						EG_API(EgTagWriteByEntry, work.slave[i].is_ovr_fifo_out_tag, &work.slave[i].is_ovr_fifo_out, sizeof(work.slave[i].is_ovr_fifo_out));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_RX_FIFO_OVR_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtBoolean, "", "RSI-CAN-E Rx Frame FIFO Overrun");
						EG_API(EgTagGetProperty, prop_buf, "Entry", &work.slave[i].is_ovr_fifo_in_tag, sizeof(work.slave[i].is_ovr_fifo_in_tag));
						EG_API(EgTagWriteByEntry, work.slave[i].is_ovr_fifo_in_tag, &work.slave[i].is_ovr_fifo_in, sizeof(work.slave[i].is_ovr_fifo_in));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_TYPE_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave Type");
						EG_API(EgTagWrite, prop_buf, (val_buf = work.slave[i].format_id, &val_buf), sizeof(val_buf));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_ID_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave Index for RSI-ECAT");
						EG_API(EgTagWrite, prop_buf, (val_buf = work.slave[i].slave_id, &val_buf), sizeof(val_buf));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_VIOS_IN_OFS_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave VIOS_IN Offset");
						EG_API(EgTagWrite, prop_buf, (val_buf = sd.dwViosInBaseOffset, &val_buf), sizeof(val_buf));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_VIOS_IN_SIZE_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave VIOS_IN Size");
						EG_API(EgTagWrite, prop_buf, (val_buf = sd.dwViosInSize, &val_buf), sizeof(val_buf));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_VIOS_OUT_OFS_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave VIOS_OUT Offset");
						EG_API(EgTagWrite, prop_buf, (val_buf = sd.dwViosOutBaseOffset, &val_buf), sizeof(val_buf));
					} {
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_VIOS_OUT_SIZE_TAG_NAME, i);
						EG_API(EgTagCreateEx, prop_buf, EgVtUInt32, "", "RSI-CAN-E Slave VIOS_OUT Size");
						EG_API(EgTagWrite, prop_buf, (val_buf = sd.dwViosOutSize, &val_buf), sizeof(val_buf));
					}

					/* TagRefINɒǉ(Diagر)BIɍ쐬ĂI-I/O̓ɂ͉eȂ */
					{
						RTCDHANDLE h;
						char sec_buf[EG_MAX_TAGNAME + 1];
						sprintf(prop_buf, CAN_TAG_NAME_BASE "%02d" CAN_SLAVE_DEV_STATE_TAG_NAME, i);
						sprintf(sec_buf, "ECAT/%d", sd.dwViosInBaseOffset + sd.dwViosInSize - sizeof(struct EL6751_VIOS_IN_STATE));
						EG_API(EgTagCreateSegment, prop_buf, EgVtSegment, sizeof(struct EL6751_VIOS_IN_STATE), sec_buf, "RSI-CAN-E Slave VIOS_IN DeviceState Image", reg_name, sizeof(reg_name), &is_link);
						/* TegRefɒǉ */
						/* @todo Open / CloseȂ(ٰߊOł) */
						#undef TARGET_NAME
						#define TARGET_NAME	(ServiceMailboxName)
						EG_API(EgMailboxOpen, ServiceMailboxName, RTCD_WRITE, &h);
						EG_API(EgMailboxSend, &h, ServiceMailboxName, EM_SERVICE_ADD_IN_TAG, prop_buf, strlen(prop_buf) + 1);
						EG_API(EgMailboxClose, &h);
					}

				}

			}

			/* ݽݽʒmނ쐬 */
			/* @memo APÍACANʐM̋NɂނmFĂ */
			/*       ̂߁Aނ̍쐬͏̍ŌɍsKv */
			{
				#undef TARGET_NAME
				#define TARGET_NAME	(CAN_TAG_NAME_BASE CAN_SLAVE_COUNT_TAG_NAME)
				EG_API(EgTagCreateEx, CAN_TAG_NAME_BASE CAN_SLAVE_COUNT_TAG_NAME, EgVtUInt32, "", "RSI-CAN-E Slave Count");
				EG_API(EgTagWrite, CAN_TAG_NAME_BASE CAN_SLAVE_COUNT_TAG_NAME, (val_buf = work.slave_count, &val_buf), sizeof(val_buf));
			}

			#undef TARGET_NAME
			#undef EG_API
		}

	}
	
	/* RunԂƂ */
	EG_TAG_WRITE(PROP_MYSERV_RUN, MyState.Run, TRUE);
	
	/* OpJڑ҂(߰ݸ) */
	/* @memo ʑ̐ڑ҂悤ɂ̂ŁAȂĂǂ */
	for (;;){
		WORD req_state, curr_state;
		__EhGetState(work.h_eh, &req_state, &curr_state);
		
		if (curr_state == MST_OPERATIONAL) break;
		
		if (MyState.req_dispose){
			/* ݾ */
			on_cancel = true;
			break;
		}
		
		/* @todo ҂Ԓ */
		RtSleep(10);
	}
	
	/* ʐMٰ */
	if (!on_cancel) for (;;){

		/* ̉̑Mڰѐ(ނɔf邽߂̂) */
		uint32_t curr_rx_count = 0, curr_tx_count = 0;
		
		/* EtherCATϽ ُJn҂ */
		if ((ret = __EhWaitForCyclic(work.h_eh, WAIT_FOREVER)) != ER_EHAPI_OK){
			/* ݾقꂽBʐMٰ߂I */
			on_cancel = true;
			Log$(ServiceRealName, EG_LOG_DBG, "CAN: Cancel[%04Xh]\n", ret);
			break;
		}
		
		if (!MyState.is_connected){
			/* ؒfo */
			if (!MyState.Error) {
				Log$(ServiceRealName, EG_LOG_ERR, "CAN: Disconnected.\n");
				EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, true);
			}
			if (MyState.OverrunCtrl == OVR_CTRL_STOP) goto fin_comm;
		}
		
		/* M */
		for (int i = 0; i < work.slave_count; i++){
			
			/* APIװݸ */
			#define CHK_ERROR_PROC(do_proc) \
				if ((do_proc) != EDGE_SUCCESS) { \
					E$("Cannot access CAN Rx Frame FIFO (%d). Status[%08Xh]\n", i, ret_d); \
					EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, true); \
					goto fin_comm; \
				}

			uint16_t remain = 0;
			int ret_d = EgTagGetRemainFIFOByEntry(work.slave[i].fifo_in, &remain);

			CHK_ERROR_PROC(ret_d);

			if (remain == 0 && work.slave[i].is_ovr_fifo_in) {
				/* ׸ނر */
				CHK_ERROR_PROC(ret_d = EG_TAG_WRITE_E(work.slave[i].is_ovr_fifo_in_tag, work.slave[i].is_ovr_fifo_in, false));
			}

			if (work.slave[i].vios_in->rx_counter != work.slave[i].vios_out->rx_counter){
				
				/* ްBFIFOɓ */
				for (int j = 0; j < work.slave[i].vios_in->num_of_msg; j++){
					
					if (remain >= FIFO_DATA_COUNT) {
						/* ݌o(@memo ްj󂷂钼OŌo) */
						bool need_stop = (MyState.OverrunCtrl == OVR_CTRL_STOP);

						if (!work.slave[i].is_ovr_fifo_in) {
							/* ۸ / ލXV */
							Log$(ServiceRealName, need_stop ? EG_LOG_ERR : EG_LOG_WRN, "CAN: Rx FIFO is full! slave=%d, remain=%d\n", i, (int)remain);
							CHK_ERROR_PROC(ret_d = EG_TAG_WRITE_E(work.slave[i].is_ovr_fifo_in_tag, work.slave[i].is_ovr_fifo_in, true));
						}
						if (need_stop) {
							EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, true);
							goto fin_comm;
						}
					}

					if (work.slave[i].format_id == CAN_COMM_SLAVE_FORMAT_ID_STD){
						/* EXT̫ϯĂɕϊĊi[ */
						struct CAN_COMM_DATA_EL6751_STD *curr = &work.slave[i].vios_in->data.std[j];
						struct CAN_COMM_DATA_EL6751_EXT dest;
						dest.head.id = curr->head.id;
						dest.head.rtr = curr->head.rtr;
						dest.head.is_ext = 0;
						dest.length = curr->head.length;
						*((QWORD *)dest.data) = *((QWORD *)curr->data); /* @warning ײݖ */
						ret_d = EgTagEnqueueFIFOByEntry(work.slave[i].fifo_in, &dest, sizeof(dest), &remain);
					}else if (work.slave[i].format_id == CAN_COMM_SLAVE_FORMAT_ID_EXT){
						/* ̂܂ܓ] */
						ret_d = EgTagEnqueueFIFOByEntry(work.slave[i].fifo_in, &work.slave[i].vios_in->data.ext[j], sizeof(work.slave[i].vios_in->data.ext[j]), &remain);
					}
					if (ret_d != EDGE_FIFO_OVERRUN) CHK_ERROR_PROC(ret_d);

				}
				
				/* Mʒm */
				work.slave[i].vios_out->rx_counter = work.slave[i].vios_in->rx_counter;
				curr_rx_count += work.slave[i].vios_in->num_of_msg;
				
			}

			#undef CHK_ERROR_PROC

		}
		
		/* M */
		for (int i = 0; i < work.slave_count; i++){
			
			/* APIװݸ */
			#define CHK_ERROR_PROC(do_proc) \
				if ((do_proc) != EDGE_SUCCESS) { \
					E$("Cannot access CAN Tx Frame FIFO (%d). Status[%08Xh]\n", i, ret_d); \
					EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, true); \
					goto fin_comm; \
				}

			uint16_t remain = 0;
			int ret_d = EgTagGetRemainFIFOByEntry(work.slave[i].fifo_out, &remain);

			CHK_ERROR_PROC(ret_d);

			if (remain == 0 && work.slave[i].is_ovr_fifo_out) {
				/* ׸ނر */
				CHK_ERROR_PROC(ret_d = EG_TAG_WRITE_E(work.slave[i].is_ovr_fifo_out_tag, work.slave[i].is_ovr_fifo_out, false));
			}

			if (remain && (work.slave[i].vios_out->tx_counter == work.slave[i].vios_in->tx_counter)){
				
				/* FIFOް && M\ */
				/* 邾Ă݂ */
				int send = 0;
				for (int j = 0; remain && (j < _countof(work.slave[i].vios_out->data.std/* 邾Ȃ̂Łc */)); j++){

					if (remain >= FIFO_DATA_COUNT) {
						/* ݌o(@memo j󂳂Ă\ް𑗏oOɁA\Ȍ茟o) */
						bool need_stop = (MyState.OverrunCtrl == OVR_CTRL_STOP);

						if (!work.slave[i].is_ovr_fifo_out) {
							/* ۸ / ލXV */
							Log$(ServiceRealName, need_stop ? EG_LOG_ERR : EG_LOG_WRN, "CAN: Tx FIFO is full! slave=%d, remain=%d\n", i, (int)remain);
							CHK_ERROR_PROC(ret_d = EG_TAG_WRITE_E(work.slave[i].is_ovr_fifo_out_tag, work.slave[i].is_ovr_fifo_out, true));
						}
						if (need_stop) {
							EG_TAG_WRITE(PROP_MYSERV_ERROR, MyState.Error, true);
							goto fin_comm;
						}
					}

					if (work.slave[i].format_id == CAN_COMM_SLAVE_FORMAT_ID_STD){
						/* STD̫ϯĂɕϊĂ瑗M */
						struct CAN_COMM_DATA_EL6751_EXT curr;
						struct CAN_COMM_DATA_EL6751_STD *dest = &work.slave[i].vios_out->data.std[j];

						ret_d = EgTagDequeueFIFOByEntry(work.slave[i].fifo_out, &curr, sizeof(curr), &remain);

						dest->head.id = curr.head.id;
						dest->head.rtr = curr.head.rtr;
						dest->head.length = curr.length;
						*((QWORD *)dest->data) = *((QWORD *)curr.data); /* @warning ײݖ */

					}else if (work.slave[i].format_id == CAN_COMM_SLAVE_FORMAT_ID_EXT){
						/* ̂܂ܓ] */
						ret_d = EgTagDequeueFIFOByEntry(work.slave[i].fifo_out, &work.slave[i].vios_out->data.ext[j], sizeof(work.slave[i].vios_out->data.ext[j]), &remain);
					}
					/* @memo ݔ͂Ŵװ(O珟DequeueȂ蔭Ȃ) */
					CHK_ERROR_PROC(ret_d);
					send++;

				}
				
				/* Mvʒm */
				work.slave[i].vios_out->num_of_msg = send;
				work.slave[i].vios_out->tx_counter = work.slave[i].vios_in->tx_counter + 1;
				curr_tx_count += send;
				
			}

			#undef CHK_ERROR_PROC
		}
		
		/* ʒmލXV */
		EG_TAG_WRITE(PROP_MYSERV_LIVE, MyState.Live, MyState.Live + 1);
		if (curr_rx_count) EG_TAG_WRITE(PROP_MYSERV_RXCOUNT, MyState.RxCount, MyState.RxCount + curr_rx_count);
		if (curr_tx_count) EG_TAG_WRITE(PROP_MYSERV_TXCOUNT, MyState.TxCount, MyState.TxCount + curr_tx_count);
	}
fin_comm:
	/* ʐMI */
	EG_TAG_WRITE(PROP_MYSERV_RUN, MyState.Run, FALSE);
	
	/* װɂʐMȈꍇ́A۾I܂łőҋ@铮Ƃ */
	/* (ؿԂگސԂƈv߂̑[u) */
	if (!on_cancel) for (;;){
		
		/* EtherCATϽ ُJn҂ */
		if ((ret = __EhWaitForCyclic(work.h_eh, WAIT_FOREVER)) != ER_EHAPI_OK) {
			/* ݾقꂽBʐMٰ߂I */
			on_cancel = true;
			Log$(ServiceRealName, EG_LOG_DBG, "CAN: Cancel[%04Xh]\n", ret);
			break;
		}

	}

	/* @memo EhClose()͍sȂ */
	/*       ĂԂeWrapECAT̒ʐM(RSI-ECAT HI API)삪xႷ */
	
	/* @memo ނ̓P͕s(EntryƂRɎ擾ł󋵉ŁASލ폜ł킯Ȃ) */
fin:
	Log$(ServiceRealName, EG_LOG_DBG, "CAN: Finish\n");
	
	/* ޽IƂʒm */
	EG_TAG_WRITE(PROP_MYSERV_STATUS, MyState.Status, 0);
	
	/* Closeɑ΂ďԑJڂʒm */
	MyState.ack_dispose = true;
}

/*****************************************************************************
* FUNCTION:			GetProperty
* DESCRIPTION:		T[rXvpeB̎擾 擾łȂ̓ftHgݒl̗p܂
*					[TODO] : KvɉĐݒ荀ڂ̑w
******************************************************************************/
void GetProperty(struct MYSTATE *state)
{
	// vpeB^OݒlQ
	int32_t		result;
	
	/* --------------------------------------------------------------------- */
	/* ʏϸ(lް̂ݑΉ) */
	#define TAG_READ(tag_name, out_var, min, max, def_val) \
		result = EgTagRead((tag_name), &(out_var), sizeof(out_var)); \
		if ((result != EDGE_SUCCESS) || (((out_var) < (min) || (out_var) > (max)))) 	/* 擾NGA܂́A͈͊O */ \
		{ \
			/* 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg */ \
			(out_var) = (def_val); \
			EgTagWrite((tag_name), &(out_var), sizeof(out_var)); \
		} \
		Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", (tag_name), (out_var)); \
	/* --------------------------------------------------------------------- */
	
	// T[rX샂[h̎擾
	TAG_READ(PROP_MYSERV_MODE, state->Mode, MODE_AUTO, MODE_AUTO/* @todo */, MODE_AUTO);

	// T[rXXbh̃vCIeBw
	TAG_READ(PROP_MYSERV_PRIORITY, state->Priority, MIN_PRIO, MAX_PRIO, DEFAULT_PRIO);
	
	// MI[o̓
	TAG_READ(PROP_MYSERV_OVR_CTRL, state->OverrunCtrl, OVR_CTRL_STOP, OVR_CTRL_RUN, OVR_CTRL_DEFAULT);

	/* ɰޖ */
	{
		//Tag̓Ǎ
		result = EgTagGetProperty(PROP_MYSERV_NODENAME, "Address", state->node_name, EG_MAX_TAGADDRESS + 1);
		if (!(result == 0 && strlen(state->node_name) > 0)){
			
			NODE_INFO node_info;
			
			if (GetRtNodeInfo(THIS_LOCATION, &node_info) == TRUE) {
				// m[h̃Rs[(擪32oCg)
				strncpy(state->node_name, node_info.szNodeName, 32);
			}
			
		}
	}
	
	#undef TAG_READ
}

/*****************************************************************************
* FUNCTION:			CreateServiceTags
* DESCRIPTION:		T[rX^O łɐĂꍇ͖Čp܂
*					 [TODO] : Kvɉč쐬^Ow(^O̐XMLɒ`邱Ƃ𐄏)
******************************************************************************/
void CreateServiceTags(struct MYSTATE *state)
{
	// T[rX^Oނ̐
	// [TODO] : KvɉĈȉR[hC
	// EgTagCreateEx(TAG_MYSERV_XXX, EgVtUInt64, "", "sample tag");
	
	/* 󋵒ʒmp */
	EgTagCreateEx(PROP_MYSERV_TXCOUNT, EgVtUInt32, "", "");	// Mڰѐ
	EgTagCreateEx(PROP_MYSERV_RXCOUNT, EgVtUInt32, "", "");	// Mڰѐ
	
	/* Žðݼ޹ǂ */
	EgTagCreateEx(PROP_MYSERV_STATUS, EgVtByte, "", "");		// ð
	EgTagCreateEx(PROP_MYSERV_ERROR,  EgVtBoolean, "", "");	// װ
	EgTagCreateEx(PROP_MYSERV_RUN,    EgVtBoolean, "", "");	// s
	EgTagCreateEx(PROP_MYSERV_LIVE,   EgVtUInt32, "", "");	// ++
	
}

/*****************************************************************************
* FUNCTION:     HiInit
*
* DESCRIPTION:
*  hCo
\*****************************************************************************/
DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiInit)	//֐ꍇs
	{
		/* ޖ */
		fnServiceTagNameCreate();
		
		/* œèǂ̎擾 */
		GetProperty(&MyState);
		
		/* ޽ނǂ̍쐬 */
		CreateServiceTags(&MyState);
		
		/* ʐMگގn */
		/* װ͖ē˂ */
		s_hThread_CAN_Comm = CreateRtThread(MyState.Priority, (LPPROC)Thread_CAN_Comm, 0x2000/* @memo I-I/O(R)ƑĂ */, &MyState);
		CatalogRtHandle(0, s_hThread_CAN_Comm, "CAN_COMM");
		
		return Lower_HiInit(szIFName, hIF, dwTimeout, dwAPIStatus);
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiOpen
*
* DESCRIPTION:
*  hCoI[v
\*****************************************************************************/
DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiOpen)	//֐ꍇs
	{
		return Lower_HiOpen(hIF, hRsi, dwTimeout, dwAPIStatus);
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiClose
*
* DESCRIPTION:
*  hCoN[Y
\*****************************************************************************/
DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiClose)	//֐ꍇs
	{
		/* Еt */
		MyState.ack_dispose = false;
		MyState.req_dispose = true; /* ʐMٰ߂ɓO̷ݾٗp */
		while (!MyState.ack_dispose){
			__EhCancelWaitForCyclic(work.h_eh, s_hThread_CAN_Comm);
			RtSleep(10);
		}
		
		return Lower_HiClose(hRsi, dwAPIStatus);
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiRead
*
* DESCRIPTION:
*  hCoǍ
\*****************************************************************************/
DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiRead)	//֐ꍇs
	{
		return Lower_HiRead(hRsi, woID, address, readsize, pData, buffersize, dwTimeout, dwAPIStatus);
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiWrite
*
* DESCRIPTION:
*  hCoݏ
\*****************************************************************************/
DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiWrite)	//֐ꍇs
	{
		return Lower_HiWrite(hRsi, woID, address, writesize, pData, dwTimeout, dwAPIStatus);	//֐Ăяo
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiReConnect
*
* DESCRIPTION:
*  Đڑp֐
\*****************************************************************************/
DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiReConnect)	//֐ꍇs
	{
		return Lower_HiReConnect(ptr, dwTimeout, dwAPIStatus);	//֐Ăяo
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiConnectChk
*
* DESCRIPTION:
*  ڑ`FbNp֐
\*****************************************************************************/
BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiConnectChk)	//֐ꍇs
	{
		return MyState.is_connected = Lower_HiConnectChk(ptr, dwTimeout, dwAPIStatus);	//֐Ăяo;
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return FALSE;
}
/*****************************************************************************
* FUNCTION:     HiWait
*
* DESCRIPTION:
*  Đڑp֐
\*****************************************************************************/
DWORD HiWait(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != Lower_HiWait)	//֐ꍇs
	{
		return Lower_HiWait(hRsi, dwTimeout, dwAPIStatus);	//֐Ăяo
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}

//----------------------------------------------------------------------------
// nCx API̴ذ߲ēǂݍݏ
//----------------------------------------------------------------------------
bool fnLoadHiApiEntry()
{
	s_hLowerWrapperLib = LoadRtLibrary(LOWER_RSL_NAME);	// RSL̓I۰ގ
	if (NULL_RTHANDLE != s_hLowerWrapperLib){			// RSL̓I۰ސ?
		//֐Ŋ֐|C^擾
		LOAD_API(0x80010000, s_hLowerWrapperLib, Lower_HiInit, "HiInit");
		LOAD_API(0x80020000, s_hLowerWrapperLib, Lower_HiOpen, "HiOpen");
		LOAD_API(0x80030000, s_hLowerWrapperLib, Lower_HiClose, "HiClose");
		LOAD_API(0x80040000, s_hLowerWrapperLib, Lower_HiRead, "HiRead");
		LOAD_API(0x80050000, s_hLowerWrapperLib, Lower_HiWrite, "HiWrite");
		LOAD_API(0x80060000, s_hLowerWrapperLib, Lower_HiReConnect, "HiReConnect");
		LOAD_API(0x80070000, s_hLowerWrapperLib, Lower_HiConnectChk, "HiConnectChk");
		LOAD_API(0x80080000, s_hLowerWrapperLib, Lower_HiWait, "HiWait");
	}else{
		printf("Load Lower Wrapper RSL Failed(%s\n", LOWER_RSL_NAME);
		return false;
	}

	s_hEhAPILib = LoadRtLibrary(EHAPI_RSL_NAME);		// RSL̓I۰ގ
	if (NULL_RTHANDLE != s_hLowerWrapperLib){			// RSL̓I۰ސ?
		//֐Ŋ֐|C^擾
		LOAD_API(0x80110000, s_hEhAPILib, __EhGetEhNodeStatus, "EhGetEhNodeStatus");
		LOAD_API(0x80120000, s_hEhAPILib, __EhOpen, "EhOpen");
		LOAD_API(0x80130000, s_hEhAPILib, __EhClose, "EhClose");
		LOAD_API(0x80140000, s_hEhAPILib, __EhFindSlave, "EhFindSlave");
		LOAD_API(0x80150000, s_hEhAPILib, __EhGetViosInAddress, "EhGetViosInAddress");
		LOAD_API(0x80160000, s_hEhAPILib, __EhGetViosOutAddress, "EhGetViosOutAddress");
		LOAD_API(0x80170000, s_hEhAPILib, __EhGetState, "EhGetState");
		LOAD_API(0x80180000, s_hEhAPILib, __EhReadOD, "EhReadOD");
		LOAD_API(0x80190000, s_hEhAPILib, __EhWriteOD, "EhWriteOD");
		LOAD_API(0x801A0000, s_hEhAPILib, __EhWaitForCyclic, "EhWaitForCyclic");
		LOAD_API(0x801B0000, s_hEhAPILib, __EhCancelWaitForCyclic, "EhCancelWaitForCyclic");
	}else{
		printf("Load Lower Wrapper RSL Failed(%s\n", EHAPI_RSL_NAME);
		return false;
	}
	
	/*  */
	return true;
}

/*****************************************************************************
* FUNCTION:     RslMain
*
* DESCRIPTION:
*  RSL Main֐
\*****************************************************************************/

BOOLEAN __stdcall RslMain(RTHANDLE hModule,
	DWORD  ul_reason_for_call,
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call) {
	case RSL_PROCESS_ATTACH: {//vZXA^b`Cxg
		/* ʑӼޭق̴߲Ă擾 */
		if (!fnLoadHiApiEntry()) return FALSE;	/* 擾łȂꍇ́A޲Яݸsɂ */
		break;
	}
	case RSL_THREAD_ATTACH:
	case RSL_THREAD_DETACH:
	case RSL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}
