//
//  RT-edge IIO(R) CAN Wrapper Lؒ`
//
//   RSL development header
//
//   Copyright (c)Micronet.Co 2024
//

#ifndef _shared_mem_H_
#define _shared_mem_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

//------------------------------------------------------------------------------
// Lشر(۸ޖ)
//------------------------------------------------------------------------------
#define SHARED_MEM_ECAT_SLAVE_PARAM		"IIOR_CAN_P"
#define SHARED_MEM_INSTANCE_FIFO_IN		"IIOR_CAN_IN"
#define SHARED_MEM_INSTANCE_FIFO_OUT	"IIOR_CAN_OUT"

//------------------------------------------------------------------------------
// ڰ̈
//------------------------------------------------------------------------------
struct CAN_COMM_SLAVE_PARAM{
	/* ڰ(EL6751)ݽݽ */
	unsigned int slave_count;
	
	/* ڰ(EL6751)ߏ(g̫ϯđΉI/Fǂ) */
	/* `l͈ȉ(`l̏ꍇ͖ƂĈ) */
	#define CAN_COMM_SLAVE_FORMAT_ID_STD	(1)	/* W̫ϯ(11bit ID)p */
	#define CAN_COMM_SLAVE_FORMAT_ID_EXT	(2)	/* g̫ϯ(29bit ID)Ή */
	uint8_t slave_format_id[0];
};

//------------------------------------------------------------------------------
// Mް ̫ϯ
//------------------------------------------------------------------------------
/* @memo ް̫ϯĂ炵̂EL6751޷(V3.9) P86`87ɋLڂ̂c{ɂꂩ??? */
/*       g̫ϯđ13޲ĂȂcB */
/*       ȂɏdvȏAׯƏ??? łɂۂ͂ȂȂcB */
/* @memo āȂнĂ݂ */
/* @memo ޷ď͑MްقȂLڂɂȂĂ(P170`P172) */
/*       ESI̧ق̒`͑Mɓ̫ϯĂɂȂĂ(LRxƓ) */
/*       Lڂ̵޼ުIndexSɂȁcۂPDOϯ߂Ăc޷ĂŒꒃ */
/*       ł͎@/ESI̋LڂɉāAMʂ̍\̂ƂĈ */

/* W̫ϯĐpI/F(ID = 11bit) */
#pragma pack(push, 1)
struct CAN_COMM_DATA_EL6751_STD{
	
	struct {
		/* @memo MSVCł́AޯĂzu */
		/* @memo MSVCł́Aޯ̨ނ̌^ςƓނ̑ޯĔzuƂĈȂ */
		/* @memo MSVCł́Aޯ̨ނ̌^ŕKv̈滲ނ܂ */
		unsigned short length: 4;	/* @memo Ll = 0`8 */
		unsigned short rtr: 1;
		unsigned short id: 11;
	} head;
	
	uint8_t data[8];
	
};
#pragma pack(push, 1)

/* g̫ϯđΉI/F(ID = 29bit) */
#pragma pack(push, 1)
struct CAN_COMM_DATA_EL6751_EXT{
	
	uint16_t length;				/* @memo Ll = 0`8 */
	struct {
		/* @memo MSVCł́AޯĂzu */
		/* @memo MSVCł́Aޯ̨ނ̌^ςƓނ̑ޯĔzuƂĈȂ */
		/* @memo MSVCł́Aޯ̨ނ̌^ŕKv̈滲ނ܂ */
		unsigned int id: 29;
		unsigned int : 1;
		unsigned int rtr: 1;
		unsigned int is_ext: 1;	/* 129bit IDA011bit ID */
	} head;
	
	uint8_t data[8];
};
#pragma pack(push, 1)

#pragma pack(push, 1)
union CAN_COMM_DATA_EL6751{
	
	/* I/Fߕް */
	struct CAN_COMM_DATA_EL6751_STD std_data;
	struct CAN_COMM_DATA_EL6751_EXT ext_data;
	
	uint8_t raw_data[14/* ̈撷 */];
	
};
#pragma pack(pop)


#ifdef __cplusplus
}
#endif // __cplusplus

#endif

