////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
// eWrapECAT.c
// DLLAvP[ṼGg|Cg`܂

#include <rt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../EgIIOR/edgeCode.h"
#include "eWrapECAT.h"
#include "../EgCommon/edgeCommon.h"
//
//{RSLŎgp^O`
//
char PROP_MYSERV_NODENAME[EG_MAX_TAGNAME + 1] = { 0 };		// m[hݒ^O
char PROP_MYSERV_WAIT_ESM[EG_MAX_TAGNAME + 1] = { 0 };		// OPXe[^XύX邩ȂtO^

#define ConvertEHHANDLE(hRsi)	*(DWORD*)&((BYTE*)hRsi)[4]
//----------------------------------------------------------------------------
// macro : Get function pointer
//----------------------------------------------------------------------------
#define E$(PMSG, ...)		printf("E$EWRAPECAT.C""[%05d] "PMSG, __LINE__, __VA_ARGS__);
#define LOAD_API(err_code, handle, pfn, name)                       \
	*((LPPROC*)&(pfn)) = GetRtProcAddress(handle, name);            \
	if( (pfn) == NULL ) {                                           \
		E$("GetRtProcAddress( %s ) failed. Status[%08Xh]\n", name, (err_code | (WORD)GetLastRtError())); \
	}	
#define _MAKEINTRESOURCE(i) ((LPSTR)((ULONG_PTR)((WORD)(i))))

//----------------------------------------------------------------------------
// [Jϐ`
//----------------------------------------------------------------------------
static RTHANDLE		s_hHiAPILib = NULL_RTHANDLE;

static RTHANDLE	s_hEhAPILib = NULL_RTHANDLE;		//WaitForCyclicŎgCu
#define EHHANDLE	void*								//WaitForCyclicŎgnh

#define ADDR_MasterDiagnostic 0x20400
#define EC_M_SNDRCVERR			0x00000002	// Error in frame sendin-receiving
#define	EC_M_PARSEERR			0x00000004	// Error in received frame process
#define	EC_M_LINKDOWN			0x00000008	// Connecion down between NIC adapter and slave
#define	EC_M_WRONGCONFIG		0x00000010	// Incorrect slave configuration
#define	EC_M_S2STIME			0x00000020	// Slave-To-Slave time out occurs
#define	EC_M_DEFAULT_DATA		0x00000040	// Default data setting occurs
#define	EC_M_WATCHDOG			0x00000080	// Watch dog time out occurs

//#define@EHHANDLE ehApi
//----------------------------------------------------------------------------
// hiecatapi ذ߲Ċi[`
//----------------------------------------------------------------------------
static DWORD(*__HiInit)(char *szIFName, char *Config, IFHANDLE *hIF, DWORD dwTimeout) = NULL;
static DWORD(*__HiOpen)(IFHANDLE hIF, char *Target, RSIHANDLE *hRsi, DWORD dwTimeout);
static DWORD(*__HiClose)(RSIHANDLE hRsi);
static DWORD(*__HiRead)(RSIHANDLE hRsi, DWORD dwAddr, void *Buf, DWORD dwSize, DWORD dwBufSize, DWORD dwTimeout);
static DWORD(*__HiWrite)(RSIHANDLE hRsi, DWORD dwAddr, void *Buf, DWORD dwSize, DWORD dwTimeout);

static DWORD(*__EhWaitForCyclic)(EHHANDLE ehApi, DWORD dwTimeOut);
/*****************************************************************************
* FUNCTION:			fnServiceTagNameCreate
* DESCRIPTION:		^O/J^O𐶐
\*****************************************************************************/
void fnServiceTagNameCreate()
{
	// T[rXvpeB^O
	sprintf(PROP_MYSERV_NODENAME, "SERVICE.%s.NodeName", ServiceRealName);			// m[hݒ^O
	sprintf(PROP_MYSERV_WAIT_ESM, "SERVICE.%s.WAIT_ESM", ServiceRealName);			// OPXe[^XύXtO^O
}
/*****************************************************************************
* FUNCTION:			fnSetConfig
* DESCRIPTION:		ݒ蕶쐬
\*****************************************************************************/
void fnSetConfig(char** ppInitConf)
{
	int32_t result;
	char* node_name;
	
	node_name = malloc(EG_MAX_TAGADDRESS + 1);//m[h̔쐬
	//Tag̓Ǎ

	//m[h
	result = EgTagGetProperty(PROP_MYSERV_NODENAME, "Address", node_name, EG_MAX_TAGADDRESS + 1);
	if (result == 0 && strlen(node_name) > 0)//̂
		fnStringSet_Str(ppInitConf, "node_name=", node_name);	// m[h

	free(node_name);
}
/*****************************************************************************
* FUNCTION:			fnSetTarget
* DESCRIPTION:		openp Target쐬
\*****************************************************************************/
void fnSetTarget(char** ppTarget)
{
	int32_t result;
	bool boFlg = false;		//^O̒l擾p

	//MۏtOҋ@LtO
	result = EgTagRead(PROP_MYSERV_WAIT_ESM, &boFlg, sizeof(bool));
	if (result == 0)
	{
		if (boFlg == true)	//truȅꍇ͕L ȊO
			fnStringSet(ppTarget, "WAIT_ESM");
	}
}
/*****************************************************************************
* FUNCTION:			fnRetValue
* DESCRIPTION:		APĨXe[^Xɖ߂l
\*****************************************************************************/
DWORD fnRetValue(DWORD dwAPIStatus)
{
	if (dwAPIStatus == 0) //0͐
		return CB_STS_OK;
	if (dwAPIStatus >= 0x20000000)
		return CB_STS_FATALERR;	//s\/vIȃG[

	return CB_STS_ERROR;//ȊO͒ʏG[\G[(~߂Ȃ)
}
/*****************************************************************************
* FUNCTION:     HiInit
*
* DESCRIPTION:
*  hCo
\*****************************************************************************/
DWORD HiInit(char* szIFName, IFHANDLE* hIF, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	char* pInitConf = NULL;

	fnServiceTagNameCreate();								//Ŏgp^O쐬
	if (NULL != __HiInit)	//֐ꍇs
	{
		//config̐ݒ tag擾
		fnSetConfig(&pInitConf);

		// InitsŐݒt@Cς邽߂ŏo bΉ
		if(pInitConf != NULL)
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Config[%s]", pInitConf);

		//	inits	
		*dwAPIStatus = __HiInit(szIFName, pInitConf, hIF, dwTimeout);	//֐Ăяo
		// T[rXNԂ̕ωOɏo͂
		if (pInitConf != NULL)
		{
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Status[%08xH]", *dwAPIStatus);
			free(pInitConf);
		}
		else
			Log$(ServiceRealName, EG_LOG_DBG, "HiInit Config = NULL, Status[%xH]", *dwAPIStatus);

		return fnRetValue(*dwAPIStatus);	//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiOpen
*
* DESCRIPTION:
*  hCoI[v
\*****************************************************************************/
DWORD HiOpen(IFHANDLE hIF, RSIHANDLE* hRsi, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	char* pTarget = NULL;
	if(NULL != __HiOpen)	//֐ꍇs
	{
		//target̐ݒ tag擾
		fnSetTarget(&pTarget);

		// InitsŐݒt@Cς邽߂ŏo bΉ
		if (pTarget != NULL)
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Target[%s]", pTarget);

		// TargetNULL
		*dwAPIStatus = __HiOpen(hIF, pTarget, hRsi, dwTimeout);	//֐Ăяo
		if (pTarget != NULL)
		{
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Target[%s], Timeout{%d], Status[%08xH]", pTarget, dwTimeout, *dwAPIStatus);
			free(pTarget);
		}
		else
			Log$(ServiceRealName, EG_LOG_DBG, "HiOpen Config = NULL, Timeout{%d], Status[%xH]", dwTimeout, *dwAPIStatus);

		return fnRetValue(*dwAPIStatus);		//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiClose
*
* DESCRIPTION:
*  hCoN[Y
\*****************************************************************************/
DWORD HiClose(RSIHANDLE hRsi, DWORD* dwAPIStatus)
{
	if (NULL != __HiClose)	//֐ꍇs
	{
		*dwAPIStatus = __HiClose(hRsi);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);	//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiRead
*
* DESCRIPTION:
*  hCoǍ
\*****************************************************************************/
DWORD HiRead(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD readsize, BYTE *pData, DWORD buffersize, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != __HiRead)	//֐ꍇs
	{
		*dwAPIStatus = __HiRead(hRsi, address, pData, readsize, buffersize, dwTimeout);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);//߂lϊ
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiWrite
*
* DESCRIPTION:
*  hCoݏ
\*****************************************************************************/
DWORD HiWrite(RSIHANDLE hRsi, WORD woID, DWORD address, DWORD writesize, BYTE *pData, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	if (NULL != __HiWrite)	//֐ꍇs
	{
		*dwAPIStatus = __HiWrite(hRsi, address, pData, writesize, dwTimeout);	//֐Ăяo
		return fnRetValue(*dwAPIStatus);//߂lϊ
	}

	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiReConnect
*
* DESCRIPTION:
*  Đڑp֐
\*****************************************************************************/
DWORD HiReConnect(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	DWORD ret = CB_STS_OK;
	EgFWdesc* egdec = (EgFWdesc*)ptr;
	if (egdec != NULL)
	{
		if (egdec->hRsi != NULL_RTHANDLE)
			ret = HiClose(egdec->hRsi, dwAPIStatus);

		if (egdec->hIF != NULL_RTHANDLE)
			return HiOpen(egdec->hIF, &egdec->hRsi, dwTimeout, dwAPIStatus);
	}
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:     HiWait
*
* DESCRIPTION:
*  Đڑp֐
\*****************************************************************************/
DWORD HiWait(RSIHANDLE hRsi, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	EHHANDLE hAPI = NULL_RTHANDLE;
	if (NULL != __EhWaitForCyclic)	//֐ꍇs
	{
		//nh擾
		hAPI = (EHHANDLE)ConvertEHHANDLE(hRsi);
		if (hAPI != NULL_RTHANDLE)
		{

			*dwAPIStatus = __EhWaitForCyclic(hAPI, dwTimeout);	//֐Ăяo
			return fnRetValue(*dwAPIStatus);//߂lϊ
		}
	}
	*dwAPIStatus = EW_NOAPI;//֐
	return CB_STS_FATALERR;
}
/*****************************************************************************
* FUNCTION:			fnECatConnectChk
* DESCRIPTION:		CxgG[ԋp`FbN
\*****************************************************************************/
DWORD fnECatConnectChk(DWORD data)
{

	// Cxgԕ G[ԋp

	if (0 != (data & EC_M_LINKDOWN)) {
		return CONNECTERR_ECAT_LINKDOWN;					// G[FNICA_v^ƃX[uԂ̐ڑ_E
	}

	if (0 != (data & EC_M_PARSEERR)) {
		return CONNECTERR_ECAT_PARSEERR;					// G[FMt[̃G[
	}

	if (0 != (data & EC_M_SNDRCVERR)) {
		return CONNECTERR_ECAT_SNDRCVERR;					// G[Ft[M̃G[ 
	}

	if (0 != (data & EC_M_WRONGCONFIG)) {
		return CONNECTERR_ECAT_WRONGCONFIG;				// G[FRtBO\ُ
	}

	if (0 != (data & EC_M_S2STIME)) {
		return CONNECTERR_ECAT_S2STIMEOUT;					// G[FX[uToX[uʐMŃ^CAEg
	}

	if (0 != (data & EC_M_DEFAULT_DATA)) {
		return CONNECTERR_ECAT_DEFAULT_DATA;				// G[FpPbgM/MG[߁AftHgf[^gpꂽ
	}

	if (0 != (data & EC_M_WATCHDOG)) {
		return CONNECTERR_ECAT_WATCHDOG;					// G[FEHb`hbO^CAEg
	}

	return 0;//Ȃ
}
/*****************************************************************************
* FUNCTION:     HiConnectChk
*
* DESCRIPTION:
*  ڑ`FbNp֐
\*****************************************************************************/
BOOL HiConnectChk(void* ptr, DWORD dwTimeout, DWORD* dwAPIStatus)
{
	DWORD ret = CB_STS_OK;				//֐߂l
	DWORD dwStatus = 0;					//ECAT G[Xe[^X
	DWORD data = 0;						//̈f[^
	//BYTE Data[4] = { 0 };
	EgFWdesc* egdec = (EgFWdesc*)ptr;	//\̕ϊ
	if (egdec != NULL)					//K݂ב݂Ȃꍇ̓G[
	{
		if (egdec->hRsi != NULL_RTHANDLE)//K݂ב݂Ȃꍇ̓G[
		{
			ret = HiRead(egdec->hRsi, 0, ADDR_MasterDiagnostic, sizeof(data), (char*)&data,  sizeof(data), dwTimeout, dwAPIStatus);	//֐Ăяo
			if (ret == CB_STS_OK)
			{
				//CxgɂăG[擾
				dwStatus = fnECatConnectChk(data);
				if (0 != dwStatus)	//G[Ԃꍇ͐ڑG[
				{
					*dwAPIStatus = dwStatus;
					return FALSE;
				}
				return TRUE;
			}
			return FALSE;//߂lϊ
		}
	}
	return FALSE;
}
//----------------------------------------------------------------------------
// nCx API̴ذ߲ēǂݍݏ
//----------------------------------------------------------------------------
bool	fnLoadHiApiEntry()
{
	s_hHiAPILib = LoadRtLibrary(HIAPI_RSL_NAME);	// RSL̓I۰ގ
	s_hEhAPILib = LoadRtLibrary(EHAPI_RSL_NAME);	// RSL̓I۰ގ(EhApi.rsl)
	if (NULL_RTHANDLE != s_hHiAPILib && NULL_RTHANDLE != s_hEhAPILib) {			// RSL̓I۰ސ?
	
		//֐Ŋ֐|C^擾
		LOAD_API(0x80010000, s_hHiAPILib, __HiInit, "Init");
		LOAD_API(0x80020000, s_hHiAPILib, __HiOpen, "Open");
		LOAD_API(0x80030000, s_hHiAPILib, __HiClose, "Close");
		LOAD_API(0x80040000, s_hHiAPILib, __HiRead, "Read");
		LOAD_API(0x80050000, s_hHiAPILib, __HiWrite, "Write");
		
		LOAD_API(0x80100000, s_hEhAPILib, __EhWaitForCyclic, "EhWaitForCyclic");
		return true;
	}
	printf("Load HiLevelApi RSL Frailed(%s\n", HIAPI_RSL_NAME);
	return false;
}
/*****************************************************************************
* FUNCTION:     RslMain
*
* DESCRIPTION:
*  RSL Main֐
\*****************************************************************************/

BOOLEAN __stdcall RslMain(RTHANDLE hModule,
	DWORD  ul_reason_for_call,
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call) {
	case RSL_PROCESS_ATTACH: //vZXA^b`Cxg
		fnLoadHiApiEntry();
		break;
	case RSL_THREAD_ATTACH:
	case RSL_THREAD_DETACH:
	case RSL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}
