////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
*
* FILE NAME:		edgeCommon.c
*
* DESCRIPTION:		ʏR[h
*
*
\*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rt.h>
#include "edgeCommon.h"

const char* APINAME_DELIMITER = "_";					//Service̋؂蕶
/*****************************************************************************
* FUNCTION:     Log$
*
* DESCRIPTION:
*  Oo
\*****************************************************************************/
void fnLog(const char* pServiceName, const char* pMode, const char * _Format, ...)
{
	va_list arg;
	char *messBuff = NULL;

	//allocate
	messBuff = (char*)malloc(1024);
	if (messBuff == NULL)
		return;
	size_t bufsize = 1024;
	memset(messBuff, 0, bufsize);
	// Logo͏
	va_start(arg, _Format);
	vsprintf_s(messBuff, bufsize, _Format, arg);
	va_end(arg);
	EgFW_PrintLog(pServiceName, pMode, messBuff);

	//free
	free(messBuff);
}
/*****************************************************************************
* FUNCTION:			fnGetApiName
* DESCRIPTION:		ServiceAPI擾
******************************************************************************/
void fnGetApiName(char** pApiName)
{
	char *context;
	*pApiName = strtok_s(ServiceRealName, APINAME_DELIMITER, &context);//؂蕶O̕擾
	if (*pApiName == NULL) *pApiName = ServiceRealName;		//NULL̏ꍇ͋؂薳ׂ̈̂܂ܕԂ
}
/*****************************************************************************
* FUNCTION:			fnStringSet
* DESCRIPTION:		newĒǉĕԂ OfreeKv
\*****************************************************************************/
void fnStringSet(char** pString, char* str)
{
	char* new_String = NULL;	//VꎞIɊi[|C^
	size_t org_strLen = 0;		//
	size_t new_strLen = 0;

	if (str == NULL || strlen(str) == 0) return;	//w肳ꂽ񂪖ꍇ͏I

	new_strLen = strlen(str);		//w肳ꂽ擾
	if (*pString != NULL)			//̕񂪂ꍇ͒ǉ
	{
		org_strLen = strlen(*pString);	//񂪂ꍇ̓J}؂Œǉ
		new_String = malloc(org_strLen + new_strLen + 1);
		if (org_strLen > 0)
			sprintf(new_String, "%s|%s", *pString, str);
		else                           //񂪖ꍇ̓Rs[
			sprintf(new_String, "%s", str);

		free(*pString);				//O̕񃁃͍폜
	}
	else {
		new_String = malloc(new_strLen);
		sprintf(new_String, "%s", str);
	}
	*pString = new_String;//ƃRs[
}
/*****************************************************************************
* FUNCTION:			fnStringSet_Str
* DESCRIPTION:		newĒǉĕԂ OfreeKv
\*****************************************************************************/
void fnStringSet_Str(char** pString, char* str1, char* str2)
{
	char* tmp_String = NULL;	//e|
	size_t org_strLen = 0;		//
	size_t new_strLen1 = 0;
	size_t new_strLen2 = 0;

	if (str1 == NULL || strlen(str1) == 0 ||
		str2 == NULL || strlen(str2) == 0) return;	//w肳ꂽ񂪖ꍇ͏I

	new_strLen1 = strlen(str1);		//w肳ꂽ擾
	new_strLen2 = strlen(str2);		//w肳ꂽ擾
	tmp_String = malloc(new_strLen1 + new_strLen2);
	sprintf(tmp_String, "%s%s", str1, str2);
	fnStringSet(pString, tmp_String);
	free(tmp_String);
}
/*****************************************************************************
* FUNCTION:			fnStringSet_Uint
* DESCRIPTION:		newĒǉĕԂ OfreeKv
\*****************************************************************************/
void fnStringSet_Uint(char** pString, char* str1, uint num)
{
	char* tmp_String = NULL;	//e|
	size_t org_strLen = 0;		//
	size_t new_strLen1 = 0;

	if (str1 == NULL || strlen(str1) == 0) return;	//w肳ꂽ񂪖ꍇ͏I

	new_strLen1 = strlen(str1);		//w肳ꂽ擾
	tmp_String = malloc(new_strLen1 + _MAXNUMLENGTH);
	sprintf(tmp_String, "%s%u", str1, num);
	fnStringSet(pString, tmp_String);
	free(tmp_String);
}