////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
*
* FILE NAME:		edgeCode.c
*
* DESCRIPTION:		RT-edge IIO(R) for INtime
*
*
\*****************************************************************************/

#include <rt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_

/*****************************************************************************
* T[rXCWP[^EvpeB^O
* ------------------------------------------------------------
* - T[rXReiECIŎw肵Namel𗘗p܂B
* - ^OEgInit()ɐ܂B
*****************************************************************************/
char IND_MYSERV_STATUS[EG_MAX_TAGNAME + 1] = { 0 };				// T[rXN
char IND_MYSERV_ERROR[EG_MAX_TAGNAME + 1] = { 0 };				// T[rXG[
char IND_MYSERV_RUN[EG_MAX_TAGNAME + 1] = { 0 };				// T[rXs
char IND_MYSERV_LIVE[EG_MAX_TAGNAME + 1] = { 0 };				// T[rXsJE^
char PROP_MYSERV_MODE[EG_MAX_TAGNAME + 1] = { 0 };				// T[rX샂[h
char PROP_MYSERV_CYCLE[EG_MAX_TAGNAME + 1] = { 0 };				// T[rXTCN(ms)
char PROP_MYSERV_AUTORUN[EG_MAX_TAGNAME + 1] = { 0 };			// T[rXJn
char PROP_MYSERV_INPRIO[EG_MAX_TAGNAME + 1] = { 0 };			// EdgeVXeւ̓̓T[rXXbhvCIeB
char PROP_MYSERV_OUTPRIO[EG_MAX_TAGNAME + 1] = { 0 };			// EdgeVXȅo̓T[rXXbhvCIeB

char PROP_MYSERV_IN_TRDNUM[EG_MAX_TAGNAME + 1] = { 0 };			// EdgeVXeւ̓̓T[rXXbh
char PROP_MYSERV_OUT_TRDNUM[EG_MAX_TAGNAME + 1] = { 0 };		// EdgeVXȅo̓T[rXXbh

char PROP_MYSERV_EXECUTE_RECONNECT[EG_MAX_TAGNAME + 1] = { 0 };	// sɍĐڑ邩ۂ̃tO
char PROP_MYSERV_CONNECT[EG_MAX_TAGNAME + 1] = { 0 };			// ʐMڑ
char PROP_MYSERV_CONNECTCHK_CYCLE[EG_MAX_TAGNAME + 1] = { 0 };	// ʐMڑԃ`FbN(ms)
char PROP_MYSERV_MEASURE[EG_MAX_TAGNAME + 1] = { 0 };			// ԌvtO

char PROP_MYSERV_RECONNECTCOUNT[EG_MAX_TAGNAME + 1] = { 0 };	// ڑ`FbNɂăG[񐔂`ɒBĐڑs
char PROP_MYSERV_OUTPUTDIFFERENT[EG_MAX_TAGNAME + 1] = { 0 };	// lOlƈႤ̂ݏo͂邩ۂ̃tO TRUE Ⴄꍇ̂ݏo FALSE ɏo
char TAG_MYSERV_DRV_APITIMEOUT[EG_MAX_TAGNAME + 1] = { 0 };		// APIR[Timeout(ms)
char TAG_MYSERV_DRV_WAITAPITIMEOUT[EG_MAX_TAGNAME + 1] = { 0 };		// WAITAPIR[Timeout(ms)
char TAG_MYSERV_USEWAIT[EG_MAX_TAGNAME + 1] = { 0 };			// TCNgp邩ۂ FALSÊƂ gp Wait֐gp ftHg gp
char TAG_MYSERV_USEKERNELTICK[EG_MAX_TAGNAME + 1] = { 0 };		// TCN̓J[leBbNgp

char TEMP_TAG_NAME[EG_MAX_TAGNAME + 1] = { 0 };					// ^OIpꎞϐ
char TAG_MYSERV_DRV_CONNECT[EG_MAX_TAGNAME + 1] = { 0 };		// ʐMڑ
char TAG_MYSERV_DRV_CONNECT_LASTERR[EG_MAX_TAGNAME + 1] = { 0 };	// ʐMڑԃG[ڍ

// vZXJ^O
char SERVICE_CATALOG_NAME[EG_MAX_CATALOGNAME] = { 0 };		// J^O

/*****************************************************************************
* FUNCTION:			comparAsc
* DESCRIPTION:		edge I/O |[g \[g@offsetŃ\[g@
\*****************************************************************************/
int comparAsc(const void* a, const void* b) {
	//NULLŃ`FbN
	if (a == NULL && b == NULL) return 0;
	if (b == NULL ) return 1;
	if (a == NULL )  return -1;
	
	// OffsetŔr
	if (((EGIOPORT*)a)->Offset > ((EGIOPORT*)b)->Offset) {
		return 1;
	}	
	else if(((EGIOPORT*)a)->Offset < ((EGIOPORT*)b)->Offset){
		return -1;
	}
	else//Offsetꏏ̏ꍇ̓rbgŔr
	{
		if (((EGIOPORT*)a)->woBitPos > ((EGIOPORT*)b)->woBitPos)
			return 1;
		else
			return -1;
	}
}
/*****************************************************************************
* FUNCTION:			fnGetBitData
* DESCRIPTION:		rbgf[^̎擾
\*****************************************************************************/
BOOL fnGetBitData(void* dst, size_t dstsize, const void* src, size_t srcsize, int16_t bit) {
	// p[^̃AhXw肪Ó
	if (dst == NULL)			return FALSE;
	if (dstsize == 0)			return FALSE;
	if (src == NULL)			return FALSE;
	if (srcsize == 0)			return FALSE;

	if (bit > 7 && (srcsize < 2 || dstsize < 2)) //2oCgȏ̃rbgwɂS炸dst/srcTCYȂꍇ̓G[
		return FALSE;

	if (bit > 7)//8bitȏ2bytef[^
		*(uint16_t*)dst = (*(uint16_t*)src & (1 << bit)) ? true : false;		// rbg̏ true or false
	else//7bitȉ1bytef[^
		*(uint8_t*)dst = (*(uint8_t*)src & (1 << bit)) ? true : false;		// rbg̏ true or false

	return TRUE;
}
/*****************************************************************************
* FUNCTION:			fnSetBitData
* DESCRIPTION:		rbgf[^̐ݒ
\*****************************************************************************/
BOOL fnSetBitData(void* dst, size_t dstsize, const void* src, size_t srcsize, int16_t bit) {
	// p[^̃AhXw肪Ó
	if (dst == NULL)			return FALSE;
	if (dstsize == 0)			return FALSE;
	if (src == NULL)			return FALSE;
	if (srcsize == 0)			return FALSE;

	if (bit > 7 && dstsize < 2) //2oCgȏ̃rbgwɂS炸dstTCYȂꍇ̓G[
		return FALSE;

	if (bit > 7)//8bitȏ2bytef[^
	{
		if (*(uint16_t*)src == 0)
			*(uint16_t*)dst &= ~(1 << bit);		// rbg𗎂Ƃ
		else
			*(uint16_t*)dst |= (1 << bit);		// rbgĂ
	}
	else//7bitȉ1bytef[^
	{
		if (*(uint8_t*)src == 0)
			*(uint8_t*)dst &= ~(1 << bit);		// rbg𗎂Ƃ
		else
			*(uint8_t*)dst |= (1 << bit);		// rbgĂ
	}
	return TRUE;
}
/*****************************************************************************
* FUNCTION:			fnIsContinuousData
* DESCRIPTION:		bit̂܂ŏp邩ۂ`FbN TRUE:p FALSE:I
\*****************************************************************************/
BOOL fnIsContinuousData(int32_t index, int32_t RefSize, EGIOPORT* pPortArray)
{
	//EGIOPORTItZbg̏ꍇłrbgf[^̏ꍇ͓f[^bitl擾̂ŏp
	if (index + 1 < RefSize &&
		pPortArray[index].Offset == pPortArray[index + 1].Offset &&
		pPortArray[index].byBitUse == true)
		return TRUE;
	return FALSE;
}
/*****************************************************************************
* FUNCTION:			fnServiceTagNameCreate
* DESCRIPTION:		^O/J^O𐶐
\*****************************************************************************/
void fnServiceTagNameCreate()
{
	// T[rXCWP[^
	sprintf(IND_MYSERV_STATUS, "SERVICE.%s.Status", ServiceRealName);		// T[rXN
	sprintf(IND_MYSERV_ERROR, "SERVICE.%s.Error", ServiceRealName);			// T[rXG[
	sprintf(IND_MYSERV_RUN, "SERVICE.%s.Run", ServiceRealName);				// T[rXs
	sprintf(IND_MYSERV_LIVE, "SERVICE.%s.Live", ServiceRealName);			// T[rXsJE^

	// T[rXvpeB^O
	sprintf(PROP_MYSERV_MODE, "SERVICE.%s.Mode", ServiceRealName);			// T[rX샂[h
	sprintf(PROP_MYSERV_CYCLE, "SERVICE.%s.Cycle", ServiceRealName);		// T[rXTCN(ms)
	sprintf(PROP_MYSERV_INPRIO, "SERVICE.%s.InPriority", ServiceRealName);	// EdgeVXeւ̓̓T[rXXbhvCIeB
	sprintf(PROP_MYSERV_OUTPRIO, "SERVICE.%s.OutPriority", ServiceRealName);// EdgeVXȅo̓T[rXXbhvCIeB
	sprintf(PROP_MYSERV_IN_TRDNUM, "SERVICE.%s.InThreadNum", ServiceRealName);		// EdgeVXeւ̓̓T[rXXbhvCIeB
	sprintf(PROP_MYSERV_OUT_TRDNUM, "SERVICE.%s.OutThreadNum", ServiceRealName);	// EdgeVXeւ̓̓T[rXXbhvCIeB
	sprintf(PROP_MYSERV_EXECUTE_RECONNECT, "SERVICE.%s.ExecuteReConnect", ServiceRealName);		// sĐڑ邩ۂ(ftHgĐڑȂ)
	sprintf(PROP_MYSERV_CONNECTCHK_CYCLE, "SERVICE.%s.ConnectChkCycle", ServiceRealName);	// ڑԊĎ(ms))
	sprintf(PROP_MYSERV_MEASURE, "SERVICE.%s.Measure", ServiceRealName);			// ԌvtO
	sprintf(PROP_MYSERV_RECONNECTCOUNT, "SERVICE.%s.ReConnectCount", ServiceRealName);	// ĐڑsJEg
	sprintf(PROP_MYSERV_OUTPUTDIFFERENT, "SERVICE.%s.OutputDifferent", ServiceRealName);	// lႤ̂ݏo͂tO
	sprintf(TAG_MYSERV_DRV_APITIMEOUT, "SERVICE.%s.Timeout", ServiceRealName);		// APIR[timeout
	sprintf(TAG_MYSERV_DRV_WAITAPITIMEOUT, "SERVICE.%s.WaitTimeout", ServiceRealName);	// WaitAPIR[timeout

	sprintf(TAG_MYSERV_USEWAIT, "SERVICE.%s.UseWait", ServiceRealName);	// Wait邩ۂ
	sprintf(TAG_MYSERV_USEKERNELTICK, "SERVICE.%s.UseKernelTick", ServiceRealName);	// J[leBbNœ邩ۂ

	// T[rX^O
	sprintf(TAG_MYSERV_DRV_CONNECT, "SERVICE.%s.Connected", ServiceRealName);	// ʐMڑ
	sprintf(TAG_MYSERV_DRV_CONNECT_LASTERR, "SERVICE.%s.ConnectLastError", ServiceRealName);	// ʐMڑԃG[ڍ
	
	// vZXJ^O
	sprintf(SERVICE_CATALOG_NAME, "EGSC%s", ServiceMailboxName);			// J^O
}

/*****************************************************************************
* FUNCTION:			fnTagWriteStatus
* PARAMETERS:		1. ύXStatus
* DESCRIPTION:		T[rXNԂ
\*****************************************************************************/
void fnTagWriteStatus(uint8_t byStatus)
{
	// ωȂꍇ́A
	if (MyState.Status == byStatus) { return; }

	// T[rXNԂ̕ωOɏo͂
	Log$(ServiceRealName, EG_LOG_OPE, "%s Change. %d > %d", ServiceStateName, MyState.Status, byStatus);

	// T[rXNԂ̍XV
	MyState.Status = byStatus;
	EgTagWrite(ServiceStateName, &MyState.Status, sizeof(MyState.Status));
}
/*****************************************************************************
* FUNCTION:			fnTagWriteRun
* DESCRIPTION:		T[rXstO
\*****************************************************************************/
void fnTagWriteRun(BOOL boRun)
{
	MyState.Run = boRun;
	EgTagWrite(ServiceStateRunName, &MyState.Run, sizeof(MyState.Run));
}
/*****************************************************************************
* FUNCTION:			fnTagWriteLive
* DESCRIPTION:		T[rXsCNg^Oɏ
\*****************************************************************************/
void fnTagWriteLive()
{
	MyState.Live++;
	EgTagWrite(ServiceStateLiveName, &MyState.Live, sizeof(MyState.Live));
}
/*****************************************************************************
* FUNCTION:			fnTagWriteError
* DESCRIPTION:		T[rXsQtOON/OFF^Oɏ
\*****************************************************************************/
void fnTagWriteError(BOOL boErr)
{
	MyState.Error = boErr;
	EgTagWrite(ServiceStateErrName, &MyState.Error, sizeof(MyState.Error));
	Log$(ServiceRealName, EG_LOG_DBG, "Error Status[%d]\n", MyState.Error);
}
/*****************************************************************************
* FUNCTION:			fnTagWriteDrvConnect
* DESCRIPTION:		ʐMڑԃtO^Oɏ
\*****************************************************************************/
void fnTagWriteDrvConnect(BOOL boConnect, DWORD errStatus)
{
	MyState.Connect = boConnect;
	EgTagWrite(TAG_MYSERV_DRV_CONNECT, &MyState.Connect, sizeof(MyState.Connect));
	EgTagWriteByEntry(MyFwDesc.pEntryConnectLastErr, &errStatus, 4);
	Log$(ServiceRealName, EG_LOG_DBG, "Connect Status[%d][0x%xH]\n", MyState.Connect, errStatus);
}

/*****************************************************************************
* FUNCTION:			fnTagWriteInThreadLastErr
* DESCRIPTION:		̓XbhŐVG[l
\*****************************************************************************/
void fnTagWriteInThreadLastErr(WORD woID, DWORD errStatus)
{
	// ParamCheak
	if ((woID < 0) || (woID > MAX_IO_THREAD)) { return; }

	EgTagWriteByEntry(MyFwDesc.stThreadInTbl[woID].pEntryThreadLastErr, &errStatus, 4);
}
/*****************************************************************************
* FUNCTION:			fnTagWriteInThreadEdgeLastErr
* DESCRIPTION:		̓XbhŐVEdgeAPIG[l
\*****************************************************************************/
void fnTagWriteInThreadEdgeLastErr(WORD woID, DWORD errStatus)
{
	// ParamCheak
	if ((woID < 0) || (woID > MAX_IO_THREAD)) { return; }

	EgTagWriteByEntry(MyFwDesc.stThreadInTbl[woID].pEntryThreadEdgeLastErr, &errStatus, 4);
}

/*****************************************************************************
* FUNCTION:			fnTagWriteOutThreadLastErr
* DESCRIPTION:		o̓XbhŐVG[l
\*****************************************************************************/
void fnTagWriteOutThreadLastErr(WORD woID, DWORD errStatus)
{
	// ParamCheak
	if ((woID < 0) || (woID > MAX_IO_THREAD)) { return; }

	EgTagWriteByEntry(MyFwDesc.stThreadOutTbl[woID].pEntryThreadLastErr, &errStatus, 4);
}
/*****************************************************************************
* FUNCTION:			fnTagWriteOutThreadEdgeLastErr
* DESCRIPTION:		o̓XbhŐVEdgeAPIG[l
\*****************************************************************************/
void fnTagWriteOutThreadEdgeLastErr(WORD woID, DWORD errStatus)
{
	// ParamCheak
	if ((woID < 0) || (woID > MAX_IO_THREAD)) { return; }

	EgTagWriteByEntry(MyFwDesc.stThreadOutTbl[woID].pEntryThreadEdgeLastErr, &errStatus, 4);
}
/*****************************************************************************
* FUNCTION:			fnAddUserFunc
* DESCRIPTION:		R[obN֐o^
*					KvΕύXsv
******************************************************************************/
void fnAddUserFunc()
{
	// ͌Œ֐ł
	cbp_Init	= CB_INIT;
	cbp_Open	= CB_OPEN;
	cbp_Close	= CB_CLOSE;
	cbp_Read	= CB_READ;
	cbp_Write	= CB_WRITE;
	cbp_MSGHandler = CB_MSGHandler;
	cbp_Wait = CB_WAIT;
}
/*****************************************************************************
* FUNCTION:			fnAddUserFunc_ConnectChk
* DESCRIPTION:		foCXڑԃ`FbN R[obN֐o^
\*****************************************************************************/
void fnAddUserFunc_ConnectChk(p_funcConnectChk pFunc)
{
	cbp_ConnectChk = pFunc;
}
/*****************************************************************************
* FUNCTION:			fnAddUserFunc_ConnectChk
* DESCRIPTION:		foCXĐڑ R[obN֐o^
\*****************************************************************************/
void fnAddUserFunc_ReConnect(p_funcReConnect pFunc)
{
	cbp_ReConnect = pFunc;
}

/*****************************************************************************
* FUNCTION:			MsgHandler
* DESCRIPTION:		Edge[U[bZ[Wnh
*                   [TODO] : KvɉăbZ[WEǉ
\*****************************************************************************/
int32_t MsgHandler(const char* sender, int32_t msgno, void *param)
{
	int32_t	result = 0;

	if (cbp_MSGHandler != NULL)		// ʃbZ[Wnh[R[obNo^̏ꍇ
	{
		//ʃbZ[W͈ȉ֐Ɏ
		result = cbp_MSGHandler(sender, msgno, param);	// bZ[WM
	}

	switch (msgno)
	{
	case EM_SERVICE_RUN:			// T[rXJnw
		Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_RUN recieved.");
		// ς݂̏ꍇ̂݁As܂
		if (MyState.InitStatus == INIT_STS_INITEND)
			result = StartService(&MyState);		// T[rXJns
		else
			MyState.InitStatus = INIT_STS_INITRUN;	// (RUNMς)ɍXV ɃT[rXJn܂
		break;
	case EM_SERVICE_STOP:			// T[rXIw
		Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_STOP recieved.");
		result = KillService(&MyState);
		break;
	case EM_SERVICE_PAUSE:			// T[rXꎞ~w
		Log$(ServiceRealName, EG_LOG_DBG, "EM_SERVICE_PAUSE recieved.");
		result = PauseService(&MyState);
		break;
	case EM_SERVICE_UPDATE:			// T[rXAbvf[gw
		switch (MyState.Mode)
		{
		case MODE_AUTO:				// TCN[hiTCNXbĥŖj
			break;
		case MODE_SEMIAUTO:			// TCN[hio͂̍XVsj
			KickOutput(&MyState);
			break;
		case MODE_MANUAL:			// 蓮TCN[hio͋ɍXVsj
			KickInput(&MyState);
			KickOutput(&MyState);
			break;
		}
		break;
	default:						//LȊO͔
		break;
	}
	return result;
}
/*****************************************************************************
* INp Segmentm
\*****************************************************************************/
void GetPSegINData(BYTE** ppSegData, DWORD* pMaxSegSize)
{
	//segment̍őTCY擾
	for (int k = 0; k < egTagRefs_IN_Count; k++)
	{
		//segmentAstringȊO͑ΏۊO
		if (egTagRefs_IN[k].Type == EgVtSegment || egTagRefs_IN[k].Type == EgVtString)
		{
			if (egTagRefs_IN[k].Size > *pMaxSegSize) *pMaxSegSize = egTagRefs_IN[k].Size;
		}
	}
	//segment̍őTCYŃm
	if (*pMaxSegSize > 0)
	{
		*ppSegData = malloc(*pMaxSegSize);
		if (*ppSegData == NULL)
			Log$(ServiceRealName, EG_LOG_ERR, "Stop IN Service. Because Cannot Create Segment Memory(%d).\n", *pMaxSegSize);
		else
			memset(*ppSegData, 0, *pMaxSegSize);
	}
}
/*****************************************************************************
* FUNCTION:			ThreadInService
* DESCRIPTION:		EdgeVXeւ̃f[^
\*****************************************************************************/
void ThreadInService(IO_TRDINFO *trdInfo)
{
	int32_t		edgeRet = 0;
	DWORD		cbRet = 0;
	DWORD		result = 0, result2 = 0;
	DWORD		apiRet = 0;
	int			index = 0;
	int			bitDataSize = 1;
	BYTE		byData[8];
	BYTE		byBitData[8];
	QWORD		qwstart, qwend;				// [Ԍv]JE^i[p
	DWORD		maxSegSize = 0;
	BYTE*		pSegData = NULL;			// segment̃f[^Rs[锠

	if (egTagRefs_IN_Count > 0 && egTagRefs_IN_PortInfo == NULL)//TagRef͓o^Ă̂edgeI/O Porto^ĂȂꍇ̓G[
	{
		Log$(ServiceRealName, EG_LOG_ERR, "Stop IN Service. Because TagRef(TagRefs_IN) edge I/O Port is NULL.\n");
		goto failed;
	}
	//segmenti[p̃|C^擾
	GetPSegINData(&pSegData, &maxSegSize);
	
	/* @memo TagRef̓Iǉłޯ̨ނɑΉłȂ(ČʂɔfȂ) */
	qsort(egTagRefs_IN_PortInfo, egTagRefs_IN_Count, sizeof(EGIOPORT), comparAsc);//EGIOPORT\[g
	while (1)
	{
		WaitForRtSemaphore(trdInfo->hTrigSem, 1, WAIT_FOREVER);		// ̓^C~OgK҂

		if (MyState.Error == true) { continue; }					// G[̓XLbv
		
		qwstart = GetPentiumCounter();								// [Ԍv]STARTJE^擾
		trdInfo->dwOpeCnt++;										// Xbh񐔍XV
		EgTagWriteByEntry(trdInfo->pEntryThreadCnt, &trdInfo->dwOpeCnt, sizeof(trdInfo->dwOpeCnt));
		cbRet = CB_STS_OK;											// Xe[^X
		edgeRet = EDGE_SUCCESS;										// Xe[^X
		// ---------------------------------------------------------------------
		// ̓^OXV (TagRefs_IN) RTCDւ̓͂܂
		// ---------------------------------------------------------------------
		for (int i = 0; i < egTagRefs_IN_Count; i++)
		{
			if (egTagRefs_IN_PortInfo[i].bIsValied != 1) continue; //Ȓlݒ肳ĂȂꍇ͏Ȃ

			memset(byData, 0, sizeof(byData));
			index = egTagRefs_IN_PortInfo[i].Index;	//\[gOindex
			if (egTagRefs_IN_PortInfo[i].byBitUse == true)//rbg͂܂Ƃ߂Ďs
			{
				//segment^Astring^̓rbgwΏۊO
				if (egTagRefs_IN[index].Type == EgVtSegment || egTagRefs_IN[index].Type == EgVtString)
					continue;

				bitDataSize = 1; //1byte擾
				if (egTagRefs_IN_PortInfo[i].woMaxBit > 7) //rbg8ȏ(WORDPʂłbitw̏ꍇ2byte擾)
					bitDataSize = 2;
				// foCX̓ R[obN
				result = cbp_Read(&MyFwDesc, trdInfo->woID, egTagRefs_IN_PortInfo[i].Offset, byData, bitDataSize, sizeof(byData), &egTagRefs_IN_PortInfo[i]);
				if (result == CB_STS_OK)
				{
					while (true)//rbgf[^͘As
					{
						memset(byBitData, 0, sizeof(byBitData));
						//oCgf[^(byData)rbgl(byBitData)擾
						if (FALSE == fnGetBitData(byBitData, sizeof(byBitData), byData, sizeof(byData), egTagRefs_IN_PortInfo[i].woBitPos))
						{
							//vIG[̂ߏI
							result = CB_STS_FATALERR;
							break;
						}
						// RTCDւ̏ݎs
						result2 = EgTagWriteByEntry(egTagRefs_IN[index].Entry, byBitData, egTagRefs_IN[index].Size);
						//EGIOPORTItZbg̏ꍇłrbgf[^̏ꍇ͓f[^bitl擾̂ŏp
						if (TRUE == fnIsContinuousData(i, egTagRefs_IN_Count, egTagRefs_IN_PortInfo))
						{
							i++;
							index = egTagRefs_IN_PortInfo[i].Index;	//\[gOindex
						}
						else//ꍇ͔
							break;
					}
				}
				cbRet |= result;
				edgeRet |= result2;
			}
			else //rbgf[^ł͂Ȃ̂ł̂܂܏
			{
				// segmentn or string̏ꍇ
				if (egTagRefs_IN[index].Type == EgVtSegment || egTagRefs_IN[index].Type == EgVtString)
				{
					if (maxSegSize < egTagRefs_IN[index].Size) {
						/* ނɎ܂ȂTagRefIɒǉꂽBmۂ */
						maxSegSize = egTagRefs_IN[index].Size;
						if (pSegData != NULL) free(pSegData), pSegData = NULL;
					}
					if (pSegData == NULL) {
						/* segmenti[̈悪ȂB蒼 */
						pSegData = malloc(maxSegSize);
					}
					if (pSegData != NULL)//mۂĂꍇ̖s
					{
						// foCX̓ R[obN
						result = cbp_Read(&MyFwDesc, trdInfo->woID, egTagRefs_IN_PortInfo[i].Offset, pSegData, egTagRefs_IN[index].Size, egTagRefs_IN[index].Size, &egTagRefs_IN_PortInfo[i]);
						if (result == CB_STS_OK)
						{
							// RTCDւ̏ݎs
							result2 = EgTagWriteSegmentByEntry(egTagRefs_IN[index].Entry, 0, pSegData, egTagRefs_IN[index].Size);
						}
					}
					else
					{
						Log$(ServiceRealName, EG_LOG_ERR, "Stop IN Service. Because Cannot Create Segment Memory(%d).\n", maxSegSize);
						goto failed;
					}
				}
				else //ȊO
				{
					// foCX̓ R[obN
					result = cbp_Read(&MyFwDesc, trdInfo->woID, egTagRefs_IN_PortInfo[i].Offset, byData, egTagRefs_IN[index].Size, sizeof(byData), &egTagRefs_IN_PortInfo[i]);
					if (result == CB_STS_OK)
					{
						// RTCDւ̏ݎs
						result2 = EgTagWriteByEntry(egTagRefs_IN[index].Entry, byData, egTagRefs_IN[index].Size);
					}
				}
				cbRet |= result;
				edgeRet |= result2;
			}
		}

		// ---------------------------------------------------------------------
		// TODO: G[CWP[^XV
		// ---------------------------------------------------------------------
		if (cbRet & CB_STS_ERROR || cbRet & CB_STS_FATALERR)		// vIG[̏ꍇ
		{
			fnTagWriteError(true);			// G[CWP[^trueɍXV
			if (cbRet & CB_STS_ERROR)
			{
				if (cbp_ReConnect != NULL)		// foCXĐڑR[obNo^̏ꍇ
				{
					if (CB_STS_OK == cbp_ReConnect(&MyFwDesc,&apiRet))	// foCXĐڑs
					{
						fnTagWriteError(false);	// ĐڑOKȂG[CWP[^falseɍXV
					}
				}
			}
		}
		else if (cbRet == CB_STS_OK)//G[ꍇ̓Xe[^X0ɂ
		{
			fnTagWriteInThreadLastErr(trdInfo->woID, 0);
		}
		fnTagWriteInThreadEdgeLastErr(trdInfo->woID, edgeRet);//edge Last Errɏ
		qwend = GetPentiumCounter();								// [Ԍv]STOPJE^擾
		UpdateIOThreadOpeTime(trdInfo, qwstart, qwend);				// [Ԍv]XbhԍXV
	}

	// 𐶐Ă폜
	if (pSegData != NULL)
	{
		free(pSegData);
		pSegData = NULL;
	}
	return;

failed:
	fnTagWriteError(true);			// G[CWP[^trueɍXV
	// 𐶐Ă폜
	if (pSegData != NULL)
	{
		free(pSegData);
		pSegData = NULL;
	}
	return;
}
/*****************************************************************************
* OUTp Segmentm
\*****************************************************************************/
void GetPSegOutData(BYTE** ppSegData, DWORD* pMaxSegSize)
{
	//segment̍őTCY擾
	for (int k = 0; k < egTagRefs_OUT_Count; k++)
	{
		//segmentAstringȊO͑ΏۊO
		if (egTagRefs_OUT[k].Type == EgVtSegment || egTagRefs_OUT[k].Type == EgVtString)
		{
			if (egTagRefs_OUT[k].Size > *pMaxSegSize) *pMaxSegSize = egTagRefs_OUT[k].Size;
		}
	}
	//segment̍őTCYŃm
	if (*pMaxSegSize > 0)
	{
		*ppSegData = malloc(*pMaxSegSize);
		if (*ppSegData == NULL)
			Log$(ServiceRealName, EG_LOG_ERR, "Stop OUT Service. Because Cannot Create Segment Memory(%d).\n", *pMaxSegSize);
		else
			memset(*ppSegData, 0, *pMaxSegSize);
	}
}
/*****************************************************************************
* FUNCTION:			ThreadOutService
* DESCRIPTION:		EdgeVXẽf[^o
\*****************************************************************************/
void ThreadOutService(IO_TRDINFO* trdInfo)
{
	int32_t		edgeRet = 0;
	int32_t		result = 0;
	DWORD		cbRet = 0;
	DWORD		apiRet = 0;
	int			index = 0;
	int			bitDataSize = 1;
	BYTE		byData[8];
	BYTE		byBitData[8];
	QWORD		qwstart, qwend;				// [Ԍv]JE^i[p
	DWORD		maxSegSize = 0;
	BYTE*		pSegData = NULL;			// segment̃f[^Rs[锠


	if (egTagRefs_OUT_Count > 0 && egTagRefs_OUT_PortInfo == NULL)//TagRef͓o^Ă̂edgeI/O Porto^ĂȂꍇ̓G[
	{
		Log$(ServiceRealName, EG_LOG_ERR, "Stop Out Service. Because TagRef(TagRefs_Out) edge I/O Port is NULL.\n");
		goto failed;
	}

	//segment̍őTCY擾
	GetPSegOutData(&pSegData, &maxSegSize);

	/* @memo TagRef̓Iǉłޯ̨ނɑΉłȂ(ČʂɔfȂ) */
	qsort(egTagRefs_OUT_PortInfo, egTagRefs_OUT_Count, sizeof(EGIOPORT), comparAsc);//EGIOPORT\[g
	while (1)
	{
		WaitForRtSemaphore(trdInfo->hTrigSem, 1, WAIT_FOREVER);		// o̓^C~OgK҂

		if (MyState.Error == true) { continue; }					// G[̓XLbv

		qwstart = GetPentiumCounter();								// [Ԍv]STARTJE^擾
		trdInfo->dwOpeCnt++;										// Xbh񐔍XV
		EgTagWriteByEntry(trdInfo->pEntryThreadCnt, &trdInfo->dwOpeCnt, sizeof(trdInfo->dwOpeCnt));
		cbRet = CB_STS_OK;											// Xe[^X
		edgeRet = EDGE_SUCCESS;										// Xe[^X
		// ---------------------------------------------------------------------
		// o̓^OXV (TagRefs_OUT) RTCD̏o͂܂
		// ---------------------------------------------------------------------
		for (int i = 0; i < egTagRefs_OUT_Count; i++)
		{
			if (egTagRefs_OUT_PortInfo[i].bIsValied != 1) continue; //Ȓlݒ肳ĂȂꍇ͏Ȃ
			
			// RTCD̓ǂݍݏs
			memset(byData, 0, sizeof(byData));
			index = egTagRefs_OUT_PortInfo[i].Index;	//\[gOindex
			if (egTagRefs_OUT_PortInfo[i].byBitUse == true)//rbg͂܂Ƃ߂Ďs
			{
				//segment^Astring^̓rbgwΏۊO
				if (egTagRefs_OUT[index].Type == EgVtSegment || egTagRefs_OUT[index].Type == EgVtString)
					continue;

				bitDataSize = 1; //1bytef[^
				if (egTagRefs_OUT_PortInfo[i].woMaxBit > 7) //rbg8ȏ(WORDPʂłbitw̏ꍇ2bytef[^)
					bitDataSize = 2;

				//foCX̒lǂݍ
				result = cbp_Read(&MyFwDesc, trdInfo->woID, egTagRefs_OUT_PortInfo[i].Offset, byData, bitDataSize, sizeof(byData), &egTagRefs_OUT_PortInfo[i]);
				if (result == CB_STS_OK)//ď
				{
					while (true)
					{
						memset(byBitData, 0, sizeof(byBitData));	//
						//^O̒lǂݍ
						result = EgTagReadByEntry(egTagRefs_OUT[index].Entry, byBitData, egTagRefs_OUT[index].Size);
						if (result != CB_STS_OK)//ď
							break;


						//ǂݍ񂾃f[^bit(ItZbg̊Ԃ@while
						if (FALSE == fnSetBitData(byData, sizeof(byData), byBitData, sizeof(byBitData), egTagRefs_OUT_PortInfo[i].woBitPos))
						{
							//vIG[̂ߏI
							result = CB_STS_FATALERR;
							break;
						}
						// ̔zɃf[^Ãf[^bitf[^łAItZbgl̏ꍇ͏𑱂
						if (TRUE == fnIsContinuousData(i, egTagRefs_OUT_Count, egTagRefs_OUT_PortInfo))
						{
							i++;
							index = egTagRefs_OUT_PortInfo[i].Index;	//\[gOindex
						}
						else//ꍇ͔
							break;
					}
					if (0 == MyState.OutputDifferentFlag || memcmp(egTagRefs_OUT[index]._byOldVal, byData, egTagRefs_OUT[index].Size) != 0)	//lꍇłރtȌꍇA܂͑O̒lƈĂ珑
					{
						//foCX֏ 8bitȏ̎w肪ꍇ2byte 8bit̏ꍇ1byte
						// foCXւ̏o R[obN
						cbRet |= cbp_Write(&MyFwDesc, trdInfo->woID, egTagRefs_OUT_PortInfo[i].Offset, byData, (long)bitDataSize, &egTagRefs_OUT_PortInfo[i]);
						memcpy(egTagRefs_OUT[index]._byOldVal, byData, sizeof(byData));
					}
				}
				cbRet |= result;
			}
			else //rbgf[^ł͂Ȃ̂ł̂܂܏
			{
				// segmentn or string̏ꍇ
				if (egTagRefs_OUT[index].Type == EgVtSegment || egTagRefs_OUT[index].Type == EgVtString)
				{
					if (maxSegSize < egTagRefs_OUT[index].Size) {
						/* ނɎ܂ȂTagRefIɒǉꂽBmۂ */
						maxSegSize = egTagRefs_OUT[index].Size;
						if (pSegData != NULL) free(pSegData), pSegData = NULL;
					}
					if (pSegData == NULL) {
						/* segmenti[̈悪ȂB蒼 */
						pSegData = malloc(maxSegSize);
					}
					if (pSegData != NULL)//mۂĂꍇ̖s
					{
						// ^Olǂݍ
						result = EgTagReadSegmentByEntry(egTagRefs_OUT[index].Entry, 0, pSegData, egTagRefs_OUT[index].Size);
						if (result == EDGE_SUCCESS)
						{
							//segment̏ꍇ͑O̒lƂ̔r͖ Ko
							// foCXւ̏o R[obN
							cbRet |= cbp_Write(&MyFwDesc, trdInfo->woID, egTagRefs_OUT_PortInfo[i].Offset, pSegData, (long)egTagRefs_OUT[index].Size, &egTagRefs_OUT_PortInfo[i]);
							
						}
					}
					else
					{
						Log$(ServiceRealName, EG_LOG_ERR, "Stop OUT Service. Because Cannot Create Segment Memory(%d).\n", maxSegSize);
						goto failed;
					}
				}
				else //̑̏ꍇ
				{
					result = EgTagReadByEntry(egTagRefs_OUT[index].Entry, byData, egTagRefs_OUT[index].Size);
					if (result == EDGE_SUCCESS)
					{
						if (0 == MyState.OutputDifferentFlag || memcmp(egTagRefs_OUT[index]._byOldVal, byData, egTagRefs_OUT[index].Size) != 0)	//lꍇłރtȌꍇA܂͑O̒lƈĂ珑
						{
							// foCXւ̏o R[obN
							cbRet |= cbp_Write(&MyFwDesc, trdInfo->woID, egTagRefs_OUT_PortInfo[i].Offset, byData, (long)egTagRefs_OUT[index].Size, &egTagRefs_OUT_PortInfo[i]);
							memcpy(egTagRefs_OUT[index]._byOldVal, byData, sizeof(byData));
						}

					}
				}
				edgeRet |= result;

			}
		}

		// ---------------------------------------------------------------------
		// TODO: G[CWP[^XV
		// ---------------------------------------------------------------------
		if (cbRet & CB_STS_ERROR || cbRet & CB_STS_FATALERR)		// vIG[̏ꍇ
		{
			fnTagWriteError(true);			// G[CWP[^trueɍXV
			if (cbRet & CB_STS_ERROR)
			{
				if (cbp_ReConnect != NULL)		// foCXĐڑR[obNo^̏ꍇ
				{
					if (CB_STS_OK == cbp_ReConnect(&MyFwDesc,&apiRet))	// foCXĐڑs
					{
						fnTagWriteError(false);	// ĐڑOKȂG[CWP[^falseɍXV
					}
				}
			}
		}
		else if (cbRet == CB_STS_OK)//G[ꍇ̓Xe[^X0ɂ
		{
			fnTagWriteOutThreadLastErr(trdInfo->woID, 0);
		}
		fnTagWriteOutThreadEdgeLastErr(trdInfo->woID, edgeRet);		//edge Last Errɏ
		qwend = GetPentiumCounter();								// [Ԍv]STOPJE^擾
		UpdateIOThreadOpeTime(trdInfo, qwstart, qwend);				// [Ԍv]XbhԍXV
	}

	// 𐶐Ă폜
	if (pSegData != NULL)
	{
		free(pSegData);
		pSegData = NULL;
	}
	return;

failed:
	fnTagWriteError(true);			// G[CWP[^trueɍXV
	// 𐶐Ă폜
	if (pSegData != NULL)
	{
		free(pSegData);
		pSegData = NULL;
	}
	return;
}

/*****************************************************************************
* FUNCTION:			ThreadConnectChk
* DESCRIPTION:		ڑԊĎXbh
*					KvΕύXsv
\*****************************************************************************/
void ThreadConnectChk(struct MYSTATE *state)
{
	RtSleepEx(1);							// ̃gK^C~OJ[leBbNɂ낦
	BOOL bConnect;
	DWORD dwStatus = 0;
	while (1)
	{
		if (MyState.Run && cbp_ConnectChk != NULL)	// T[rXsԁAR[obNo^̏ꍇA
		{
			if (state->EndStartFlag == true)			// xȏX^[gꍇɃ`FbN
			{
				bConnect = cbp_ConnectChk(&MyFwDesc, &dwStatus);	// foCXڑԔ
				if (MyState.Connect != bConnect)
				{
					fnTagWriteDrvConnect(bConnect, dwStatus);		// ڑԃ^OXV
				}
			}
		}
		RtSleepEx(MyState.ConnectChkCycle);			// ڑԊĎ҂
	}
}
/*****************************************************************************
* FUNCTION:			ThreadAutoCycle
* DESCRIPTION:		Waits
\*****************************************************************************/
bool ExecuteWait(struct MYSTATE *state)
{
	DWORD cbRet = CB_STS_OK;
	DWORD dwErrStatus = 0;
	//Waitꍇł֐pӂĂꍇ̂ݎs
	if (state->ExecuteWaitDrv == TRUE && MyFwDesc.RSLHiWait != NULL)
	{
		cbRet = cbp_Wait(&MyFwDesc, &dwErrStatus);	// Wait
		if (cbRet == CB_STS_OK)//͍ēxWait
			return true;
		else//G[̎ G[IDo
		{
			fnTagWriteDrvConnect(FALSE, dwErrStatus);	// G[ɂ
			return false;
		}
	}
	return false;
}
/*****************************************************************************
* FUNCTION:			ThreadAutoCycle
* DESCRIPTION:		EdgeVXeo͎TCNXbh
*					KvΕύXsv
\*****************************************************************************/
void ThreadAutoCycle(struct MYSTATE *state)
{
	RtSleepEx(1);							// ̃gK^C~OJ[leBbNɂ낦

	while (1)
	{
		fnTagWriteLive();					// T[rXsJE^

		if (state->Run)						// T[rXsԂȂ珈
		{
			if (state->Connect)				// foCXڑ̂ݏ
			{
				switch (state->Mode)		// T[rX샂[hɉĕ
				{
				case MODE_AUTO:				// TCN[hio͋ɎXVj
					KickInput(state);
					KickOutput(state);
					break;
				case MODE_SEMIAUTO:			// TCNi͂̂ݎXVAo͂EM_SERVICE_UPDATEŎw߁j
					KickInput(state);
					break;
				case MODE_MANUAL:			// 蓮TCNio͂EM_SERVICE_UPDATEŎw߂̂Ŗj
					break;
				}
				if (ExecuteWait(state) == true)	//Waits ̓Rej[
					continue;
			}
		}
		if(state->UseKernelTick == TRUE)
			knRtSleep(1);					// J[leBbNő҂
		else
			RtSleepEx(state->Cycle);		// TCN҂
	}
}


/*****************************************************************************
* FUNCTION:			KickInput
* DESCRIPTION:		̓T[rX1LbN
*					KvΕύXsv
******************************************************************************/
void KickInput(struct MYSTATE *state)
{
	for (int inLp = 0; inLp < state->InThreadNum; inLp++)
	{
		ReleaseRtSemaphore(MyFwDesc.stThreadInTbl[inLp].hTrigSem, 1);
	}
}
/*****************************************************************************
* FUNCTION:			KickOutput
* DESCRIPTION:		o̓T[rX1LbN
*					KvΕύXsv
******************************************************************************/
void KickOutput(struct MYSTATE *state)
{
	for (int inLp = 0; inLp < state->OutThreadNum; inLp++)
	{
		ReleaseRtSemaphore(MyFwDesc.stThreadOutTbl[inLp].hTrigSem, 1);
	}
}
/*****************************************************************************
* FUNCTION:			CreateServiceTags
* DESCRIPTION:		T[rX^O łɐĂꍇ͖Čp܂
*					 [TODO] : Kvɉč쐬^Ow(^O̐XMLɒ`邱Ƃ𐄏)
******************************************************************************/
int32_t CreateServiceTags(struct MYSTATE *state)
{
	int32_t		result = 0;

	// T[rX^Oނ̐
	// [TODO] : KvɉĈȉR[hC
	//result |= EgTagCreateEx(TAG_MYSERV_XXX, EgVtUInt64, "", "sample tag");

	// ̓Xbh֘A^O
	for (int inLp = 0; inLp < state->InThreadNum; inLp++)
	{
		// ̓Xbh
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_Cnt", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtUInt32, "", "");
		// ̓Xbh
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_Time", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// ̓XbhŒZ
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_TimeMin", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// ̓XbhŒ
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_TimeMax", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// ̓XbhŐVG[l
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_LastError", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtUInt32, "", "");
	}

	// o̓Xbh֘A^O
	for (int inLp = 0; inLp < state->OutThreadNum; inLp++)
	{
		// o̓Xbh
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_Cnt", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtUInt32, "", "");
		// o̓Xbh
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_Time", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// o̓XbhŒZ
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_TimeMin", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// o̓XbhŒ
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_TimeMax", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtFloat, "", "");
		// o̓XbhŐVG[l
		sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_LastError", ServiceRealName, inLp);
		result |= EgTagCreateEx(TEMP_TAG_NAME, EgVtUInt32, "", "");
	}

	// ̑^O
	result |= EgTagCreateEx(TAG_MYSERV_DRV_CONNECT, EgVtBoolean, "", "");	// ʐMڑ
	result |= EgTagCreateEx(TAG_MYSERV_DRV_CONNECT_LASTERR, EgVtUInt32, "", "");	// ʐMڑԃG[ڍ

	// Gg[o^
	EgTagGetProperty(TAG_MYSERV_DRV_CONNECT_LASTERR, "Entry", &MyFwDesc.pEntryConnectLastErr, sizeof(MyFwDesc.pEntryConnectLastErr));

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:			GetProperty
* DESCRIPTION:		T[rXvpeB̎擾 擾łȂ̓ftHgݒl̗p܂
*					[TODO] : KvɉĐݒ荀ڂ̑w
******************************************************************************/
int32_t GetProperty(struct MYSTATE *state)
{
	// vpeB^OݒlQ
	int32_t		result;

	// T[rX샂[h̎擾
	result = EgTagRead(PROP_MYSERV_MODE, &state->Mode, sizeof(state->Mode));
	if ((result != EDGE_SUCCESS) || ((state->Mode < 1 || state->Mode > 3)))	// 擾NGA܂́A͈͊O
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->Mode = DEFAULT_MODE;
		EgTagWrite(PROP_MYSERV_MODE, &state->Mode, sizeof(state->Mode));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_MODE, state->Mode);

	// T[rXTCN̎擾
	result = EgTagRead(PROP_MYSERV_CYCLE, &state->Cycle, sizeof(state->Cycle));
	if ((result != EDGE_SUCCESS) || (state->Cycle < 1))	// 擾NGA܂́A͈͊O
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->Cycle = DEFAULT_CYCLE;
		EgTagWrite(PROP_MYSERV_CYCLE, &state->Cycle, sizeof(state->Cycle));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_CYCLE, state->Cycle);

	// ̓T[rXXbh̃vCIeBw
	result = EgTagRead(PROP_MYSERV_INPRIO, &state->InPriority, sizeof(state->InPriority));
	if ((result != EDGE_SUCCESS) || (state->InPriority < MIN_PRIO) || (state->InPriority > MAX_PRIO))
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->InPriority = DEFAULT_INPRIO;
		EgTagWrite(PROP_MYSERV_INPRIO, &state->InPriority, sizeof(state->InPriority));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_INPRIO, state->InPriority);

	// o̓T[rXXbh̃vCIeBw
	result = EgTagRead(PROP_MYSERV_OUTPRIO, &state->OutPriority, sizeof(state->OutPriority));
	if ((result != EDGE_SUCCESS) || (state->OutPriority < MIN_PRIO) || (state->OutPriority > MAX_PRIO))
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->OutPriority = DEFAULT_OUTPRIO;
		EgTagWrite(PROP_MYSERV_OUTPRIO, &state->OutPriority, sizeof(state->OutPriority));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_OUTPRIO, state->OutPriority);

	// ̓T[rXXbh̐w
	result = EgTagRead(PROP_MYSERV_IN_TRDNUM, &state->InThreadNum, sizeof(state->InThreadNum));
	if ((result != EDGE_SUCCESS) || (state->InThreadNum < 0) || (state->InThreadNum > MAX_IO_THREAD))
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->InThreadNum = DEFAULT_IO_THREAD;
		EgTagWrite(PROP_MYSERV_IN_TRDNUM, &state->InThreadNum, sizeof(state->InThreadNum));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_IN_TRDNUM, state->InThreadNum);

	// o̓T[rXXbh̐w
	result = EgTagRead(PROP_MYSERV_OUT_TRDNUM, &state->OutThreadNum, sizeof(state->OutThreadNum));
	if ((result != EDGE_SUCCESS) || (state->OutThreadNum < 0) || (state->OutThreadNum > MAX_IO_THREAD))
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->OutThreadNum = DEFAULT_IO_THREAD;
		EgTagWrite(PROP_MYSERV_OUT_TRDNUM, &state->OutThreadNum, sizeof(state->OutThreadNum));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_OUT_TRDNUM, state->OutThreadNum);

	
	// sĐڑ邩ۂ̃tO̎擾
	result = EgTagRead(PROP_MYSERV_EXECUTE_RECONNECT, &state->ExecuteReConnect, sizeof(state->ExecuteReConnect));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->ExecuteReConnect = DEFAULT_EXECUTE_RECONNECT;
		EgTagWrite(PROP_MYSERV_EXECUTE_RECONNECT, &state->ExecuteReConnect, sizeof(state->ExecuteReConnect));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_EXECUTE_RECONNECT, state->ExecuteReConnect);

	// ڑԊĎ̎擾
	result = EgTagRead(PROP_MYSERV_CONNECTCHK_CYCLE, &state->ConnectChkCycle, sizeof(state->ConnectChkCycle));
	if ((result != EDGE_SUCCESS) || (state->ConnectChkCycle < 1))	// 擾NGA܂́A͈͊O
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->ConnectChkCycle = DEFAULT_CONNECTCHK_CYCLE;
		EgTagWrite(PROP_MYSERV_CONNECTCHK_CYCLE, &state->ConnectChkCycle, sizeof(state->ConnectChkCycle));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_CONNECTCHK_CYCLE, state->ConnectChkCycle);

	// ԌvtO̎擾
	result = EgTagRead(PROP_MYSERV_MEASURE, &state->IsMeasure, sizeof(state->IsMeasure));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->IsMeasure = false;
		EgTagWrite(PROP_MYSERV_MEASURE, &state->IsMeasure, sizeof(state->IsMeasure));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_MEASURE, state->IsMeasure);

	// ڑsJEg̎擾
	result = EgTagRead(PROP_MYSERV_RECONNECTCOUNT, &state->dwReConnectCount, sizeof(state->dwReConnectCount));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->dwReConnectCount = 10000;
		EgTagWrite(PROP_MYSERV_RECONNECTCOUNT, &state->dwReConnectCount, sizeof(state->dwReConnectCount));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_RECONNECTCOUNT, state->dwReConnectCount);
	
	// lႤꍇ̂ݏo͂tO̎擾
	result = EgTagRead(PROP_MYSERV_OUTPUTDIFFERENT, &state->OutputDifferentFlag, sizeof(state->OutputDifferentFlag));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->OutputDifferentFlag = 0;
		EgTagWrite(PROP_MYSERV_OUTPUTDIFFERENT, &state->OutputDifferentFlag, sizeof(state->OutputDifferentFlag));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", PROP_MYSERV_OUTPUTDIFFERENT, state->OutputDifferentFlag);
	
	// timeoutԂ̎擾
	result = EgTagRead(TAG_MYSERV_DRV_APITIMEOUT, &MyState.Timeout, sizeof(MyState.Timeout));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		MyState.Timeout = DEF_TIMEOUT;
		EgTagWrite(TAG_MYSERV_DRV_APITIMEOUT, &MyState.Timeout, sizeof(MyState.Timeout));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", TAG_MYSERV_DRV_APITIMEOUT, MyState.Timeout);

	// waittimeoutԂ̎擾
	result = EgTagRead(TAG_MYSERV_DRV_WAITAPITIMEOUT, &MyState.WaitTimeout, sizeof(MyState.WaitTimeout));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		MyState.WaitTimeout = DEF_WAITTIMEOUT;
		EgTagWrite(TAG_MYSERV_DRV_WAITAPITIMEOUT, &MyState.WaitTimeout, sizeof(MyState.WaitTimeout));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", TAG_MYSERV_DRV_WAITAPITIMEOUT, MyState.WaitTimeout);
	
	// Wait삷邩ۂ̃tO̎擾
	result = EgTagRead(TAG_MYSERV_USEWAIT, &state->ExecuteWaitDrv, sizeof(state->ExecuteWaitDrv));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->ExecuteWaitDrv = DEFAULT_EXECUTE_WAITDRV;
		EgTagWrite(TAG_MYSERV_USEWAIT, &state->ExecuteWaitDrv, sizeof(state->ExecuteWaitDrv));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", TAG_MYSERV_USEWAIT, state->ExecuteWaitDrv);

	
	// J[leBbNœ삷邩ۂ̃tO̎擾
	result = EgTagRead(TAG_MYSERV_USEKERNELTICK, &state->UseKernelTick, sizeof(state->UseKernelTick));
	if (result != EDGE_SUCCESS)	// 擾NG
	{
		// 擾NGA܂́A͈͊O ̏ꍇ́AftHglZbg
		state->UseKernelTick = FALSE;
		EgTagWrite(TAG_MYSERV_USEKERNELTICK, &state->UseKernelTick, sizeof(state->UseKernelTick));
	}
	Log$(ServiceRealName, EG_LOG_DBG, "%s [%d]", TAG_MYSERV_USEKERNELTICK, state->UseKernelTick);

	//
	// [TODO] : Cӂ̃T[rXvpeBw
	//

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:			StartService
* DESCRIPTION:		T[rXJn o͉\ɂȂ܂
*					KvΕύXsv
******************************************************************************/
int32_t StartService(struct MYSTATE *state)
{
	DWORD cbRet = CB_STS_OK;
	DWORD dwErrStatus = 0;
	fnTagWriteRun(true);						// T[rXsԂɍXV
	cbRet = cbp_Open(&MyFwDesc,&dwErrStatus);	// ڑI[v R[obN
	if (cbRet != CB_STS_OK)
		Log$(ServiceRealName, EG_LOG_ERR, "fnOpen error. Status[0x%xH]. ErrStatus[0x%xH]", cbRet, dwErrStatus);

	fnTagWriteDrvConnect(MyState.Connect, dwErrStatus);	// ڑԍXV
	fnTagWriteError(MyState.Error);				// G[ԍXV
	state->EndStartFlag = true;					// StartServiceItO
	return cbRet;
}

/*****************************************************************************
* FUNCTION:			PauseService
* DESCRIPTION:		T[rXꎞ~ o͂ȂȂ܂
*					KvΕύXsv
******************************************************************************/
int32_t PauseService(struct MYSTATE *state)
{
	fnTagWriteRun(false);			// T[rX~ԂɍXV

	return 0;
}

/*****************************************************************************
* FUNCTION:			CreateInThreadInfo
* DESCRIPTION:		̓Xbh쐬
*					KvΕύXsv
******************************************************************************/
void CreateInThreadInfo(WORD woID, IO_TRDINFO* trdInfo)
{
	// ParamCheck
	if (trdInfo == NULL) { return; }
	if (woID < 0 || woID > MAX_IO_THREAD) { return; }

	// Xbhi[
	trdInfo = &MyFwDesc.stThreadInTbl[woID];
	trdInfo->woID = woID;										// XbhID
	trdInfo->byPriority = MyState.InPriority;					// vCIeB
	trdInfo->dwStackSize = 0x2000;								// X^bNTCY(Œ)
	trdInfo->hTrigSem = CreateRtSemaphore(0, 10, FIFO_QUEUING);	// ̓T[rXXbhpgKZ}tH

	// v֘A^OEntryێ
	// ̓Xbh
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_Cnt", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadCnt, sizeof(trdInfo->pEntryThreadCnt));
	// ̓Xbh
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_Time", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTime, sizeof(trdInfo->pEntryThreadTime));
	// ̓XbhŒZ
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_TimeMin", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTimeMin, sizeof(trdInfo->pEntryThreadTimeMin));
	// ̓XbhŒ
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_TimeMax", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTimeMax, sizeof(trdInfo->pEntryThreadTimeMax));
	// ̓XbhŐVG[l
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_LastError", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadLastErr, sizeof(trdInfo->pEntryThreadLastErr));
	// ̓XbhŐVEdgeAPIG[l
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.InThread%02d_EdgeLastError", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadEdgeLastErr, sizeof(trdInfo->pEntryThreadEdgeLastErr));
}

/*****************************************************************************
* FUNCTION:			CreateOutThreadInfo
* DESCRIPTION:		o̓Xbh쐬
*					KvΕύXsv
******************************************************************************/
void CreateOutThreadInfo(WORD woID, IO_TRDINFO* trdInfo)
{
	// ParamCheck
	if (trdInfo == NULL) { return; }
	if (woID < 0 || woID > MAX_IO_THREAD) { return; }

	// Xbhi[
	trdInfo = &MyFwDesc.stThreadOutTbl[woID];
	trdInfo->woID = woID;										// XbhID
	trdInfo->byPriority = MyState.OutPriority;					// vCIeB
	trdInfo->dwStackSize = 0x2000;								// X^bNTCY(Œ)
	trdInfo->hTrigSem = CreateRtSemaphore(0, 10, FIFO_QUEUING);	// o̓T[rXXbhpgKZ}tH

	// v֘A^OEntryێ
	// o̓Xbh
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_Cnt", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadCnt, sizeof(trdInfo->pEntryThreadCnt));
	// o̓Xbh
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_Time", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTime, sizeof(trdInfo->pEntryThreadTime));
	// o̓XbhŒZ
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_TimeMin", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTimeMin, sizeof(trdInfo->pEntryThreadTimeMin));
	// o̓XbhŒ
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_TimeMax", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadTimeMax, sizeof(trdInfo->pEntryThreadTimeMax));
	// o̓XbhŐVG[l
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_LastError", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadLastErr, sizeof(trdInfo->pEntryThreadLastErr));
	// o̓XbhŐVEdgeAPIG[l
	sprintf(TEMP_TAG_NAME, "SERVICE.%s.OutThread%02d_EdgeLastError", ServiceRealName, woID);
	EgTagGetProperty(TEMP_TAG_NAME, "Entry", &trdInfo->pEntryThreadEdgeLastErr, sizeof(trdInfo->pEntryThreadEdgeLastErr));	
}

/*****************************************************************************
* FUNCTION:			InitService
* DESCRIPTION:		T[rX̏
*					KvΕύXsv
******************************************************************************/
int32_t InitService(struct MYSTATE *state)
{
	int32_t		result;
	EDGECONFIG	config = EDGE_CONFIG_DEFAULT;
	DWORD dwErrStatus = 0;
	RTHANDLE	hThread;
	DWORD		cbRet;
	char		chThdCtlg[16];
	IO_TRDINFO*	trdInfo;

	state->InitStatus = INIT_STS_INIT;							// ɍXV

	config.fpUserMessHdlFunc = MsgHandler;						// EdgebZ[W[Unh̎w
	
	result = EgInit(&config);									// Edget[[N̏
	if (result != EDGE_SUCCESS)
		WARN(result);


	MyState.dwReConnectCount = 10000;							// ݒ菉 10000G[ɂȂĐڑs ftHgl

	fnServiceTagNameCreate();									// T[rXReit^O𐶐

	result = GetProperty(state);								// T[rXvpeB̃[h
	if (result != EDGE_SUCCESS)
		WARN(result);

	result = CreateServiceTags(state);							// T[rX^O̐
	if (result != EDGE_SUCCESS)
		WARN(result);

	SetRtProcessMaxPriority(0, 0);								// vZXŏʃvCIeB
	fnAddUserFunc();											// K{̃R[obN֐o^
																// TODO: Ăяo^C~OmF
	cbRet = cbp_Init(&MyFwDesc, &dwErrStatus);								// foCX R[obN
	if (cbRet == CB_STS_OK)
	{
		// ǉ̃R[obN֐o^
		fnAddUserFunc_ConnectChk((p_funcConnectChk)MyFwDesc.cb_ConnectChk);	// foCXڑ`FbN
		fnAddUserFunc_ReConnect((p_funcReConnect)MyFwDesc.cb_ReConnect);	// foCXĐڑ
	}

	// o̓T[rXXbh̐
	for (int inLp = 0; inLp < MyState.OutThreadNum; inLp++)
	{
		if (inLp == MAX_IO_THREAD) { break; }					// ͈͊Ȍꍇ͏𔲂

		trdInfo = &MyFwDesc.stThreadOutTbl[inLp];
		CreateOutThreadInfo(inLp, trdInfo);						// Xbh񐶐
		trdInfo->hThread = CreateRtThread(trdInfo->byPriority, ThreadOutService, trdInfo->dwStackSize, trdInfo);
		memset(chThdCtlg, 0x00, sizeof(chThdCtlg));
		sprintf(chThdCtlg, "%s%02x", "OutServ", inLp);			// J^O
		CatalogRtHandle(0, trdInfo->hThread, chThdCtlg);		// J^O(G[͖)
	}

	// ̓T[rXXbh̐
	for (int inLp = 0; inLp < MyState.InThreadNum; inLp++)
	{
		if (inLp == MAX_IO_THREAD) { break; }					// ͈͊Ȍꍇ͏𔲂

		trdInfo = &MyFwDesc.stThreadInTbl[inLp];
		CreateInThreadInfo(inLp, trdInfo);						// Xbh񐶐
		trdInfo->hThread = CreateRtThread(trdInfo->byPriority, ThreadInService, trdInfo->dwStackSize, trdInfo);
		memset(chThdCtlg, 0x00, sizeof(chThdCtlg));
		sprintf(chThdCtlg, "%s%02x", "InServ", inLp);			// J^O
		CatalogRtHandle(0, trdInfo->hThread, chThdCtlg);		// J^O(G[͖)
	}

	uint8_t trigprio = (state->OutPriority < state->InPriority) ? state->OutPriority : state->InPriority;	// ق̃vCIeB擾
	hThread = CreateRtThread(trigprio, ThreadAutoCycle, 0x2000, state);		// T[rXTCNXbh̐
	CatalogRtHandle(0, hThread, "AutoCycle");

	hThread = CreateRtThread(trigprio, ThreadConnectChk, 0x2000, state);	// ڑԊĎXbh̐
	CatalogRtHandle(0, hThread, "ConChk");

	RTHANDLE hRoot = GetRtThreadHandles(ROOT_PROCESS);			// vZXJ^O
	RTHANDLE hThisProc = GetRtThreadHandles(THIS_PROCESS);
	UncatalogRtHandle(hRoot, SERVICE_CATALOG_NAME);
	CatalogRtHandle(hRoot, hThisProc, SERVICE_CATALOG_NAME);
	SetLastRtError(0);

	fnTagWriteStatus(SERVICE_UP);								// T[rXNԍXV

	if (state->InitStatus == INIT_STS_INITRUN)					// (RUNMς)̏ꍇ
	{
		// r EM_SERVICE_RUN MĂꍇ́Aɓ
		state->InitStatus = INIT_STS_INITEND;					// ɍXV
		StartService(state);									// T[rXJn
	}
	state->InitStatus = INIT_STS_INITEND;						// ɍXV

	return result;
}

/*****************************************************************************
* FUNCTION:			KillService
* DESCRIPTION:		T[rX폜ivZX~j
*					̊֐߂邱Ƃ͂܂
******************************************************************************/
int32_t KillService(struct MYSTATE *state)
{
	DWORD dwErrStatus = 0;
	PauseService(state);					// T[rX~v

	cbp_Close(&MyFwDesc, &dwErrStatus);		// ڑN[Y

	fnTagWriteDrvConnect(MyState.Connect, dwErrStatus);	// ڑԍXV
	fnTagWriteError(MyState.Error);			// G[ԍXV
	fnTagWriteStatus(SERVICE_DOWN);			// T[rX_E

	TerminateRtProcess(0, 1, 1000);			// vZXɏIv
											// łEgFinalizełȂB߂ĂȂȂ܂B
	printf("[LOG] : End %s Service\n", ServiceRealName);
	return 0;
}
/// <summary>
/// [jObZ[W
/// </summary>
/// <param name="position">蔭 __LINE__w</param>
/// <param name="reason">sRR[h</param>
void WarningMsg(int32_t position, int32_t reason)
{
	printf("%s service warning at line(%d) ,reason 0x%08x\n", ServiceRealName, position, reason);
}

 

/*****************************************************************************
* FUNCTION:			UpdateIOThreadOpeTime
* DESCRIPTION:		o̓XbhԂ̍XV
******************************************************************************/
void UpdateIOThreadOpeTime(IO_TRDINFO* trdInfo, QWORD start, QWORD end)
{
	float time;
	// ԌvtOON̏ꍇ̂ݏ
	if (MyState.IsMeasure == false) { return; }

	// ParamChek
	if (trdInfo == NULL) { return; }
	if (start == 0 || end == 0) { return; }

	// ԎZo
	time = (float)CalcTime(start, end);

	// ---------------------------------
	// ̏ԍXV
	// ---------------------------------
	trdInfo->flTime = time;
	EgTagWriteByEntry(trdInfo->pEntryThreadTime, &trdInfo->flTime, sizeof(trdInfo->flTime));

	// ---------------------------------
	// ŒZԍXV
	// ---------------------------------
	if ((trdInfo->flTimeMin == 0)
		|| ((trdInfo->flTimeMin > time) && (time != 0)))
	{
		trdInfo->flTimeMin = time;
		EgTagWriteByEntry(trdInfo->pEntryThreadTimeMin, &trdInfo->flTimeMin, sizeof(trdInfo->flTimeMin));
	}
	// ---------------------------------
	// ŒԍXV
	// ---------------------------------
	if (trdInfo->flTimeMax < time)
	{
		trdInfo->flTimeMax = time;
		EgTagWriteByEntry(trdInfo->pEntryThreadTimeMax, &trdInfo->flTimeMax, sizeof(trdInfo->flTimeMax));
	}
}
/*****************************************************************************
* FUNCTION:			GetPentiumCounter
* DESCRIPTION:		CPUNbNJE^̎擾
*					iSpeedStep@\̂CPUł͗pł܂j
******************************************************************************/
_inline QWORD GetPentiumCounter(void)
{
	_asm    rdtsc
}

/*****************************************************************************
* FUNCTION:			GetCPUSpeed
* DESCRIPTION:		CPUx̌v( Hz )
******************************************************************************/
DWORD GetCPUSpeed(void)
{
	SYSINFO         sSysInfo;
	DWORD           PentiumTicksPerUsec;
	DWORD           dwResult;

	CopyRtSystemInfo(&sSysInfo);
	PentiumTicksPerUsec = sSysInfo.PentiumTicksPerUsec;
	dwResult = PentiumTicksPerUsec * 1000000;
	return dwResult;
}

/*****************************************************************************
* FUNCTION:			CalcTime
* DESCRIPTION:		Ԃ̎Zo( ms )
******************************************************************************/
double CalcTime(QWORD start, QWORD end)
{
	double  dblCPUspeed;
	dblCPUspeed = (double)1000000000 / (double)GetCPUSpeed();
	return ((double)(end - start) * dblCPUspeed / 1000 / 1000);	// msŕԋp
}
